C*********************************************************************
c NEW DATA 960325 from PL
c The data is available in xforb_pl_960325.f
c
c Not included new data are :
c - C III, Mg I, Al II, Si III (BEFORB)
c - Ne VI (BFORB)
c - Ar V, Ca VII, Mg VII, Fe XIII (CFORB)
c - Ca II (KFORB)
C*********************************************************************


C*********************************************************************
      subroutine bforb(te,xe,i,denh,abund,f21,f345t12,f43,f54,
     &fp21,fp345t12,fp43,fp54,t21,t345t12,t43,t54,
     &s21,s345t12,s43,s54,wl345t12,
     &co21,co345t12,co43,co54,cool)
C*********************************************************************
C  Forbidden lines (B I-like). Enumeration of the ions are: (= I)
C  1 = C II   2 = N III   3 = O IV   4 = S IV   5 = Si II  
C  The atom is treated as a 5-level atom.
C  (Reduced to a 2-level atom for E32/Tev > 20)
c
c Additional data for Ne VI in xforb.f
c
c  NEW DATA 960325 :
C  A-values not mentioned specifically are from Mendoza ('83).
C  A-values for C II from Biemont et al. (J. Phys.B, 27, 5841, '94.) 
C  A-values for N III from Brage et al. (ApJ, 445, 457, '95). 
C  (These A-values are somewhat lower than those of Biemont et al, 
C  J.Phys.B, '94.) Si II from Calamai et al. (ApJ 415, L59, '93). 
C  A43 and A54 are isoelectronically guessed for N III. 
C  For S IV, Si II and Ne VI they are put equal to the values for O IV. 
C  A21 and om21 for Si II from Kafatos & Lynch, ApJS 42, 611, 1980. 
C  A21 of Ne VI from Mendoza ('83) and for intercombination lines from
C  Dankwort & Trefftz (A & A, 65, 93, '78).
C  For C and O we also use Opacity Project data (Blum & Pradhan, ApJS 
C  80, 425, 1992). For O IV and Ne VI we use the collisional strengths
C  of Zhang et al. (A & A, 283, 319, '93). N III is updated with Stafford, 
C  Bell, & Hibbert, MN 266, 715 (1994). om34, om35 and om45 isoelectronically 
C  guessed for Si at 1E4 K (use S IV's T-dependence for Si II).
C  Collisions with H for fine structure lines of C II and Si II are
C  included (E.Roueff, A&A 234, 567, 1990).
C  Energy levels of C II, N III & O IV slightly changed by Peng & Pradhan
C  (AAS, 112, 151, '95.)
c*************************************************************************
c  Old Data  No longer used :
C ( A-values mainly from Mendoza. Si II also from Calamai et al., ApJ 415,
C  L59 (1993). A43 and A54 are isoelectronically guessed 
C  for N III. For S IV  and Si II they are put equal to the values for
C  O IV. A21 and om21 for Si II from Kafatos & Lynch, ApJS 42, 611,
C  1980. A-values for N III from Fang et al. (ApJL 413, L141, 1993) are
C  included (using branching ratios as in Nussbaumer & Storey 1979).
C  (These A-values are considerably higher than those by Stafford, Bell &
C  Hibbert, MN 260, L11 (1993), or other theoretical estimates.)
C  C and O updated with Opacity Project data (Blum & Pradhan, ApJS 
C  80, 425, 1992). N III updated with Stafford, Bell & Hibbert, MN 266, 715
C  (1994). om34, om35 and om45 isoelectronically guessed for Si at 1E4 K. 
C  (use S IV's T-dependence for Si II).
C  Collisions with H for fine structure lines of C II and Si II are
C  included (E.Roueff, A&A 234, 567, 1990).)
C*********************************************************************
      implicit real*8(a-h,o-z)
C
      include 'INCLUDE/PARAM.IOR'
      parameter(itmax=50)
c
      common/cbforb/initb(5),jlb(5,5,5),klb(5,5,5)
      common/cden/den
      common/ctpar/tday,dts,iss,iss1,itd
      common/depthind/id
      common/cmat/a(mmax,mmax),b(mmax)
      common/cebin/e1(ne),en(ne),jmax
      common/cfj/fj(ne),fjidm1(ne),fjc(0:ne),fjcidm1(ne)
      common/cphed/phed(0:ne),phextot,phextc,phextl,phexlm(mid,lmax),
     &     eq1(1200),klq1(1200),kl1m
      common/cscat/fjsc(mid,0:lmax),kksc(lmax),iscv(0:lmax),
     &           is1(lmax),is0(lmax),is2(lmax),iscm,klsc,iflscat
      data pi/3.1415926e0/,tol/0.00001/
c hc=h*c=6.626e-27 erg s *2.9979e10 cm/s = 1.9864e-16 erg cm
      data hc/1.9864e-16/
c
      dimension ene2(5),ene3(5),ene4(5),ene5(5),a21(5),a31(5),
     &a41(5),a32(5),a42(5),a52(5),a43(5),a54(5),om12(5),om13(5),
     &om14(5),om15(5),om23(5),om24(5),om25(5),om34(5),om35(5),
     &om45(5),al12(5),al13(5),al14(5),al15(5),al23(5),al24(5),
     &al25(5),al34(5),al35(5),al45(5),g(5),ama(5),x(5)
c
c old data 
c      data ene2/.007932,.02163,.04792,.1177,.03558/
c      data ene3/5.3314,7.0909,8.8248,8.8192,5.3095/
c      data ene4/5.3340,7.0984,8.8411,8.8618,5.3230/
c      data ene5/5.3376,7.1084,8.8640,8.9296,5.3447/
c      data a21/2.29d-6,4.77d-5,5.20d-4,7.73d-3,2.17d-4/,
c      data a31/5.53d1,4.91d2,1.22d3,5.50d4,5.20d3/
c      data a41/1.71,9.80,32.4,140.,13.2/
c      data a32/65.5,528.,1.24d3,3.39d4,4.41d3/
c      data a42/5.24,64.6,236.,1.95d4,1.22d3/
c      data a52/43.2,308.,937.,3.95d4,2.46d3/
c      data a43/2.39d-7,3.5d-6,3*5.07d-5/
c      data a54/3.67d-7,6.1d-6,3*1.02d-4/
c      data om12/0.,1.44,2.42,6.42,3.78/
c      data om13/.242,.198,.133,.51,.406/
c      data om14/.362,.298,.201,.87,.692/
c      data om15/.235,.201,.137,.95,.752/
c      data om23/.177,.151,.102,.66,.545/
c      data om24/.477,.399,.27,1.47,1.17/
c      data om25/1.02,.844,.569,2.53,2.01/
c      data om34/.824,1.10,1.09,3.04,2.00/
c      data om35/.853,.668,.687,2.53,1.85/
c      data om45/1.98,2.04,2.05,5.85,4.50/
c      data al12/0.,.182,.092,2*0./,al13/.029,.063,.163,2*-.16/
c      data al14/.035,.083,.187,2*-.133/,al15/.062,.185,.316,2*-.121/
c      data al23/.057,.16,.296,2*-.122/,al24/.046,.126,.243,2*-.134/
c      data al25/.036,.089,.196,2*-.123/,al34/.365,.072,.106,2*-.174/
c      data al35/.186,.08,.107,2*-.141/,al45/.269,.08,.107,2*-.197/
c      data g/2.,4.,2.,4.,6./
c      data ama/12.,14.,16.,32.1,28.09/
c
c new data 960325
      data ene2/.007932,.02163,.04789,.1177,.03558/
      data ene3/5.3283,7.0869,8.7861,8.8192,5.3095/
      data ene4/5.3310,7.0943,8.8361,8.8618,5.3230/
      data ene5/5.3346,7.1044,8.8590,8.9296,5.3447/
      data a21/2.29d-6,4.77d-5,5.20d-4,7.73d-3,2.17d-4/
      data a31/7.27d1,3.61d2,1.22d3,5.50d4,5.20d3/
      data a41/1.88,9.11,32.4,140.,13.2/
      data a32/82.8,372.,1.24d3,3.39d4,4.41d3/
      data a42/10.3,65.1,236.,1.95d4,1.22d3/
      data a52/50.9,282.,937.,3.95d4,2.46d3/
      data a43/2.39d-7,3.5d-6,3*5.07d-5/
      data a54/3.67d-7,6.1d-6,3*1.02d-4/
      data om12/0.,1.44,2.60,6.42,3.78/
      data om13/.242,.198,.139,.51,.406/
      data om14/.362,.298,.217,.87,.692/
      data om15/.235,.201,.169,.95,.752/
      data om23/.177,.151,.123,.66,.545/
      data om24/.477,.399,.309,1.47,1.17/
      data om25/1.02,.844,.619,2.53,2.01/
      data om34/.824,1.10,1.20,3.04,2.00/
      data om35/.853,.668,.822,2.53,1.85/
      data om45/1.98,2.04,2.35,5.85,4.50/
      data al12/0.,.182,-.398,2*0./
      data al13/.029,.063,-.309,2*-.16/
      data al14/.035,.083,-.328,2*-.133/
      data al15/.062,.185,.091,2*-.121/
      data al23/.057,.16,-.377,2*-.122/
      data al24/.046,.126,-.357,2*-.134/
      data al25/.036,.089,-.33,2*-.123/
      data al34/.365,.072,-.557,2*-.174/
      data al35/.186,.08,-.275,2*-.141/
      data al45/.269,.08,-.287,2*-.197/
      data g/2.,4.,2.,4.,6./
      data ama/12.,14.,16.,32.1,28.09/
C
      co21=0.d0
      co345t12=0.d0
      co43=0.d0
      co54=0.d0
      cool=0.0d0
      f21=0.0d0
      f345t12=0.0d0
      f43=0.0d0
      f54=0.0d0
      fp21=0.0d0
      fp345t12=0.0d0
      fp43=0.0d0
      fp54=0.0d0
      t21=0.0d0
      t345t12=0.0d0
      t43=0.0d0
      t54=0.0d0
      s21=0.0d0
      s345t12=0.0d0
      s43=0.0d0
      s54=0.0d0
      IF (abund.ge.1.d-10) THEN
c
      tmx=2.d5
      tev=te/1.1609d4
      t4=te/1.d4
      time=8.64e4*tday
      deni=den*abund
      dene=den*xe
      cons=8.63d-6*dene/dsqrt(te)
c
      e21=ene2(i)
      e31=ene3(i)
      e41=ene4(i)
      e51=ene5(i)
      e32=ene3(i)-ene2(i)
      e42=ene4(i)-ene2(i)
      e52=ene5(i)-ene2(i)
      e43=ene4(i)-ene3(i)
      e53=ene5(i)-ene3(i)
      e54=ene5(i)-ene4(i)
c
      e345t12=((g(3)*ene3(i)+g(4)*ene4(i)+g(5)*ene5(i))/
     &     (g(3)+g(4)+g(5)))-((g(2)*ene2(i))/(g(1)+g(2)))
c
      if (initb(i).eq.0) then
         do j1=1,jmax
            if(e21.gt.en(j1).and.e21.le.en(j1+1)) then
               jlb(i,2,1)=j1
               jlb(i,1,2)=j1
               goto 91
            endif
         enddo
 91      continue
         do j1=1,jmax
            if(e31.gt.en(j1).and.e31.le.en(j1+1)) then
               jlb(i,3,1)=j1
               jlb(i,1,3)=j1
               goto 92
            endif
         enddo
 92      continue
         do j1=1,jmax
            if(e41.gt.en(j1).and.e41.le.en(j1+1)) then
               jlb(i,4,1)=j1
               jlb(i,1,4)=j1
               goto 93
            endif
         enddo
 93      continue
         do j1=1,jmax
            if(e51.gt.en(j1).and.e51.le.en(j1+1)) then
               jlb(i,5,1)=j1
               jlb(i,1,5)=j1
               goto 94
            endif
         enddo
 94      continue
         do j1=1,jmax
            if(e32.gt.en(j1).and.e32.le.en(j1+1)) then
               jlb(i,3,2)=j1
               jlb(i,2,3)=j1
               goto 95
            endif
         enddo
 95      continue
         do j1=1,jmax
            if(e42.gt.en(j1).and.e42.le.en(j1+1)) then
               jlb(i,4,2)=j1
               jlb(i,2,4)=j1
               goto 96
            endif
         enddo
 96      continue
         do j1=1,jmax
            if(e52.gt.en(j1).and.e52.le.en(j1+1)) then
               jlb(i,5,2)=j1
               jlb(i,2,5)=j1
               goto 97
            endif
         enddo
 97      continue
         do j1=1,jmax
            if(e43.gt.en(j1).and.e43.le.en(j1+1)) then
               jlb(i,4,3)=j1
               jlb(i,3,4)=j1
               goto 98
            endif
         enddo
 98      continue
         do j1=1,jmax
            if(e53.gt.en(j1).and.e53.le.en(j1+1)) then
               jlb(i,5,3)=j1
               jlb(i,3,5)=j1
               goto 99
            endif
         enddo
 99      continue
         do j1=1,jmax
            if(e54.gt.en(j1).and.e54.le.en(j1+1)) then
               jlb(i,5,4)=j1
               jlb(i,4,5)=j1
               goto 89
            endif
         enddo
 89      continue
c
         initb(i)=1
      endif
c
c wl i cm
      wl21=12398.54d-8/e21
      wl21u3=wl21**3
      wl31=12398.54d-8/e31
      wl31u3=wl31**3
      wl41=12398.54d-8/e41
      wl41u3=wl41**3
      wl51=12398.54d-8/e51
      wl51u3=wl51**3
      wl32=12398.54d-8/e32
      wl32u3=wl32**3
      wl42=12398.54d-8/e42
      wl42u3=wl42**3
      wl52=12398.54d-8/e52
      wl52u3=wl52**3
      wl43=12398.54d-8/e43
      wl43u3=wl43**3
      wl53=12398.54d-8/e53
      wl53u3=wl53**3
      wl54=12398.54d-8/e54
      wl54u3=wl54**3
      wl345t12=12398.54d-8/e345t12
      wl345t12u3=wl345t12**3
c
      if (i.eq.1) then
      	o12=dmax1(1.58d0,1.58d0*(te/1.d3)**0.11d0)
      elseif(i.eq.2) then
      	o12=cheb(tmx,te,0.724d0,0.2349d0,-0.0682d0,-0.0517d0)
      elseif(i.gt.2) then
      	o12=om12(i)*t4**al12(i)
      endif
      c21=cons*o12/g(2)
C - H-atom collisions for C II and Si II
      if(i.eq.1) c21=c21+2.05d-9*denh*(te/2.d3)**.0759
      if(i.eq.5) c21=c21+1.1d-9*denh*(te/2.d3)**.345
      c12=c21*fexp(-e21/tev)*g(2)/g(1)
      if ((e32/tev).lt.2.d1) then
         if(i.ne.2) then
      	    o13=om13(i)*t4**al13(i)
	    o14=om14(i)*t4**al14(i)
      	    o15=om15(i)*t4**al15(i)
      	    o23=om23(i)*t4**al23(i)
      	    o24=om24(i)*t4**al24(i)
      	    o25=om25(i)*t4**al25(i)
      	    o34=om34(i)*t4**al34(i)
      	    o35=om35(i)*t4**al35(i)
      	    o45=om45(i)*t4**al45(i)
         else
      	    o13=cheb(tmx,te,-3.6087d0,-0.0656d0,-0.0831d0,-0.0165d0)
      	    o14=cheb(tmx,te,-2.7917d0,-0.0501d0,-0.0914d0,-0.0197d0)
      	    o15=cheb(tmx,te,-3.5774d0,0.0274d0,-0.1330d0,-0.0337d0)
      	    o23=cheb(tmx,te,-4.1572d0,0.0119d0,-0.1247d0,-0.0311d0)
      	    o24=cheb(tmx,te,-2.2053d0,-0.0191d0,-0.1080d0,-0.0257d0)
      	    o25=cheb(tmx,te,-0.7075d0,-0.0465d0,-0.0934d0,-0.0204d0)
      	    o34=cheb(tmx,te,-0.0975d0,0.0837d0,-0.0437d0,-0.0195d0)
      	    o35=cheb(tmx,te,-0.7808d0,0.1475d0,-0.0418d0,-0.0211d0)
      	    o45=cheb(tmx,te,1.2787d0,0.1128d0,-0.0426d0,-0.0203d0)
         endif
         c31=cons*o13/g(3)
         c41=cons*o14/g(4)
         c51=cons*o15/g(5)
         c32=cons*o23/g(3)
         c42=cons*o24/g(4)
         c52=cons*o25/g(5)
         c43=cons*o34/g(4)
         c53=cons*o35/g(5)
         c54=cons*o45/g(5)
         c13=c31*fexp(-e31/tev)*g(3)/g(1)
         c14=c41*fexp(-e41/tev)*g(4)/g(1)
         c15=c51*fexp(-e51/tev)*g(5)/g(1)
         c23=c32*fexp(-e32/tev)*g(3)/g(2)
         c24=c42*fexp(-e42/tev)*g(4)/g(2)
         c25=c52*fexp(-e52/tev)*g(5)/g(2)
         c34=c43*fexp(-e43/tev)*g(4)/g(3)
         c35=c53*fexp(-e53/tev)*g(5)/g(3)
         c45=c54*fexp(-e54/tev)*g(5)/g(4)
      endif
c
c  Photoexcitation/deexcitation (stimulated) by continuum ... 
c
      j21=jlb(i,2,1)
      j31=jlb(i,3,1)
      j41=jlb(i,4,1)
      j51=jlb(i,5,1)
      j32=jlb(i,3,2)
      j42=jlb(i,4,2)
      j52=jlb(i,5,2)
      j43=jlb(i,4,3)
      j53=jlb(i,5,3)
      j54=jlb(i,5,4)
c  ... and by lines
      k21=klb(i,2,1)
      k31=klb(i,3,1)
      k41=klb(i,4,1)
      k51=klb(i,5,1)
      k32=klb(i,3,2)
      k42=klb(i,4,2)
      k52=klb(i,5,2)
      k43=klb(i,4,3)
      k53=klb(i,5,3)
      k54=klb(i,5,4)
c  change the unit from ../eV to ../Hz
c      flc=fjc(j1)/2.41838e14
c      q1=1./(2.41838e14*1.602e-12)
c      pe21=0.5*(wl21*wl21)*a21(i)*flc/(e21*1.602e-12)
c
      fl21=fjc(j21)/2.41838e14
      fl21=fl21+fjsc(id,iscv(k21))
      pe21=0.5*(wl21*wl21)*a21(i)*fl21/(e21*1.602e-12)
      pe12=(g(2)/g(1))*pe21
      if (pe12.gt.0.) then
         frl=fjsc(id,iscv(k21))/fl21
         frc=1.-frl
         pe12c=pe12*frc
         pe21c=pe21*frc
         pe12l=pe12*frl
         pe21l=pe21*frl
      else
         pe12c=0.d0
         pe21c=0.d0
         pe12l=0.d0
         pe21l=0.d0
      endif
c
      fl31=fjc(j31)/2.41838e14
      fl31=fl31+fjsc(id,iscv(k31))
      pe31=0.5*(wl31*wl31)*a31(i)*fl31/(e31*1.602e-12)
      pe13=(g(3)/g(1))*pe31
      if (pe13.gt.0.) then
         frl=fjsc(id,iscv(k31))/fl31
         frc=1.-frl
         pe13c=pe13*frc
         pe31c=pe31*frc
         pe13l=pe13*frl
         pe31l=pe31*frl
      else
         pe13c=0.d0
         pe31c=0.d0
         pe13l=0.d0
         pe31l=0.d0
      endif
c
      fl41=fjc(j41)/2.41838e14
      fl41=fl41+fjsc(id,iscv(k41))
      pe41=0.5*(wl41*wl41)*a41(i)*fl41/(e41*1.602e-12)
      pe14=(g(4)/g(1))*pe41
      if (pe14.gt.0.) then
         frl=fjsc(id,iscv(k41))/fl41
         frc=1.-frl
         pe14c=pe14*frc
         pe41c=pe41*frc
         pe14l=pe14*frl
         pe41l=pe41*frl
      else
         pe14c=0.d0
         pe41c=0.d0
         pe14l=0.d0
         pe41l=0.d0
      endif
c      fl51=fjc(j51)/2.41838e14
c      fl51=fl51+fjsc(id,iscv(k51))
c      pe51=0.5*(wl51*wl51)*a51(i)*fl51/(e51*1.602e-12)
c      pe15=(g(5)/g(1))*pe51
c
      fl32=fjc(j32)/2.41838e14
      fl32=fl32+fjsc(id,iscv(k32))
      pe32=0.5*(wl32*wl32)*a32(i)*fl32/(e32*1.602e-12)
      pe23=(g(3)/g(2))*pe32
      if (pe23.gt.0.) then
         frl=fjsc(id,iscv(k32))/fl32
         frc=1.-frl
         pe23c=pe23*frc
         pe32c=pe32*frc
         pe23l=pe23*frl
         pe32l=pe32*frl
      else
         pe23c=0.d0
         pe32c=0.d0
         pe23l=0.d0
         pe32l=0.d0
      endif
c
      fl42=fjc(j42)/2.41838e14
      fl42=fl42+fjsc(id,iscv(k42))
      pe42=0.5*(wl42*wl42)*a42(i)*fl42/(e42*1.602e-12)
      pe24=(g(4)/g(2))*pe42
      if (pe24.gt.0.) then
         frl=fjsc(id,iscv(k42))/fl42
         frc=1.-frl
         pe24c=pe24*frc
         pe42c=pe42*frc
         pe24l=pe24*frl
         pe42l=pe42*frl
      else
         pe24c=0.d0
         pe42c=0.d0
         pe24l=0.d0
         pe42l=0.d0
      endif
c
      fl52=fjc(j52)/2.41838e14
      fl52=fl52+fjsc(id,iscv(k52))
      pe52=0.5*(wl52*wl52)*a52(i)*fl52/(e52*1.602e-12)
      pe25=(g(5)/g(2))*pe52
      if (pe25.gt.0.) then
         frl=fjsc(id,iscv(k52))/fl52
         frc=1.-frl
         pe25c=pe25*frc
         pe52c=pe52*frc
         pe25l=pe25*frl
         pe52l=pe52*frl
      else
         pe25c=0.d0
         pe52c=0.d0
         pe25l=0.d0
         pe52l=0.d0
      endif
c
      fl43=fjc(j43)/2.41838e14
      fl43=fl43+fjsc(id,iscv(k43))
      pe43=0.5*(wl43*wl43)*a43(i)*fl43/(e43*1.602e-12)
      pe34=(g(4)/g(3))*pe43
      if (pe34.gt.0.) then
         frl=fjsc(id,iscv(k43))/fl43
         frc=1.-frl
         pe34c=pe34*frc
         pe43c=pe43*frc
         pe34l=pe34*frl
         pe43l=pe43*frl
      else
         pe34c=0.d0
         pe43c=0.d0
         pe34l=0.d0
         pe43l=0.d0
      endif
c      fl53=fjc(j53)/2.41838e14
c      fl53=fl53+fjsc(id,iscv(k53))
c      pe53=0.5*(wl53*wl53)*a53(i)*fl53/(e53*1.602e-12)
c      pe35=(g(5)/g(3))*pe53
c
      fl54=fjc(j54)/2.41838e14
      fl54=fl54+fjsc(id,iscv(k54))
      pe54=0.5*(wl54*wl54)*a54(i)*fl54/(e54*1.602e-12)
      pe45=(g(5)/g(4))*pe54
      if (pe45.gt.0.) then
         frl=fjsc(id,iscv(k54))/fl54
         frc=1.-frl
         pe45c=pe45*frc
         pe54c=pe54*frc
         pe45l=pe45*frl
         pe54l=pe54*frl
      else
         pe45c=0.d0
         pe54c=0.d0
         pe45l=0.d0
         pe54l=0.d0
      endif
c
c  start-values
      x(1)=1.0
      do j=2,5
         x(j)=1.d-10
      enddo
c
      do it=1,itmax
c
c calculate the escape probability : p21
c p21
         t0=wl21u3*a21(i)*g(2)*deni*x(1)*(1.-g(1)*x(2)
     &		/(g(2)*x(1)))*time/(8.*pi*g(1))
         if (t0.lt.0.01) then
            p21=1.-0.5*t0+(t0**2)/6.
         elseif(t0.ge.0.01) then
            p21=(1.-fexp(-t0))/t0
         endif
c
         if ((e32/tev).lt.2.d1) then
c calculate escape probability : p31,p32,p41,p42,p43,p52,p54
c p31
            t0=wl31u3*a31(i)*g(3)*deni*x(1)*(1.-g(1)*x(3)
     &		/(g(3)*x(1)))*time/(8.*pi*g(1))
            if (t0.lt.0.01) then
               p31=1.-0.5*t0+(t0**2)/6.
            elseif(t0.ge.0.01) then
               p31=(1.-fexp(-t0))/t0
            endif
c p32
            t0=wl32u3*a32(i)*g(3)*deni*x(2)*(1.-g(2)*x(3)
     &		/(g(3)*x(2)))*time/(8.*pi*g(2))
            if (t0.lt.0.01) then
               p32=1.-0.5*t0+(t0**2)/6.
            elseif(t0.ge.0.01) then
               p32=(1.-fexp(-t0))/t0
            endif
c p41
            t0=wl41u3*a41(i)*g(4)*deni*x(1)*(1.-g(1)*x(4)
     &		/(g(4)*x(1)))*time/(8.*pi*g(1))
            if (t0.lt.0.01) then
               p41=1.-0.5*t0+(t0**2)/6.
            elseif(t0.ge.0.01) then
               p41=(1.-fexp(-t0))/t0
            endif
c p42
            t0=wl42u3*a42(i)*g(4)*deni*x(2)*(1.-g(2)*x(4)
     &		/(g(4)*x(2)))*time/(8.*pi*g(2))
            if (t0.lt.0.01) then
               p42=1.-0.5*t0+(t0**2)/6.
            elseif(t0.ge.0.01) then
               p42=(1.-fexp(-t0))/t0
            endif
c p43
            t0=wl43u3*a43(i)*g(4)*deni*x(3)*(1.-g(3)*x(4)
     &		/(g(4)*x(3)))*time/(8.*pi*g(3))
            if (t0.lt.0.01) then
               p43=1.-0.5*t0+(t0**2)/6.
            elseif(t0.ge.0.01) then
               p43=(1.-fexp(-t0))/t0
            endif
c p52
            t0=wl52u3*a52(i)*g(5)*deni*x(2)*(1.-g(2)*x(5)
     &		/(g(5)*x(2)))*time/(8.*pi*g(2))
            if (t0.lt.0.01) then
               p52=1.-0.5*t0+(t0**2)/6.
            elseif(t0.ge.0.01) then
               p52=(1.-fexp(-t0))/t0
            endif
c p54
            t0=wl54u3*a54(i)*g(5)*deni*x(4)*(1.-g(4)*x(5)
     &		/(g(5)*x(4)))*time/(8.*pi*g(4))
            if (t0.lt.0.01) then
               p54=1.-0.5*t0+(t0**2)/6.
            elseif(t0.ge.0.01) then
               p54=(1.-fexp(-t0))/t0
            endif
c
            do j=1,5
               b(j)=0.d0
               a(1,j)=1.d0
            enddo	
            b(1)=1.d0
            a(2,1)=-c12-pe12*p21
            a(2,2)=c21+c23+c24+c25+p21*a21(i)
            a(2,2)=a(2,2)+pe21*p21+pe23*p32+pe24*p42+pe25*p52
            a(2,3)=-(c32+p32*(a32(i)+pe32))
            a(2,4)=-(c42+p42*(a42(i)+pe42))
            a(2,5)=-(c52+p52*(a52(i)+pe52))
            a(3,1)=-c13-pe13*p31
            a(3,2)=-c23-pe23*p32
            a(3,3)=c31+c32+c34+c35+p31*(a31(i)+pe31)+
     &           p32*(a32(i)+pe32)+pe34*p43
            a(3,4)=-(c43+p43*(a43(i)+pe43))
            a(3,5)=-c53
            a(4,1)=-c14-pe14*p41
            a(4,2)=-c24-pe24*p42
            a(4,3)=-c34-pe34*p43
            a(4,4)=c41+c42+c43+c45+p41*(a41(i)+pe41)+p42*(a42(i)+pe42)+
     &           p43*(a43(i)+pe43)+pe45*p54
            a(4,5)=-(c54+p54*(a54(i)+pe54))
            a(5,1)=-c15
            a(5,2)=-c25-pe25*p52
            a(5,3)=-c35
            a(5,4)=-c45-pe45*p54
            a(5,5)=c51+c52+c53+c54+p52*(a52(i)+pe52)+p54*(a54(i)+pe54)
c
            call matrixb(5,6)
c
            dxmax=0.
            do j=1,5
               dx=abs((b(j)-x(j))/b(j))
               if (dx.gt.dxmax) dxmax=dx
               x(j)=b(j)
            enddo
         else
            a(1,1)=1.d0
            a(1,2)=1.d0
            a(2,1)=-c12-pe12*p21
            a(2,2)=c21+p21*(a21(i)+pe21)
            b(1)=1.d0
            b(2)=0.0d0
            call matrixb(2,6)
c         
            dxmax=0.
            do j=1,2
               dx=abs((b(j)-x(j))/b(j))
               if (dx.gt.dxmax) dxmax=dx
               x(j)=b(j)
            enddo
         endif
         if(dxmax.lt.tol) goto 9988
      enddo
      if (it.ge.itmax) write(50,701) 'bforb : no conv!',i,tday,abund,id
9988  continue
 701  format(a,i5,f10.2,1pe12.4,i5)
c
      elab=(1.6022d-12*abund)/dene
      if ((e32/tev).lt.2.d1) then
         co21=elab*(e21*(x(1)*c12-x(2)*c21))
         co345t12=elab*(e31*(x(1)*c13-x(3)*c31)+
     &        e41*(x(1)*c14-x(4)*c41)+e51*(x(1)*c15-
     &        x(5)*c51)+e32*(x(2)*c23-x(3)*c32)+
     &        e42*(x(2)*c24-x(4)*c42)+e52*(x(2)*c25-x(5)*c52)+
     &        e43*(x(3)*c34-x(4)*c43)+e53*(x(3)*c35-x(5)*c53))
         co43=elab*(e43*(x(3)*c34-x(4)*c43))
         co54=elab*(e54*(x(4)*c45-x(5)*c54))
c
c         cool=elab*(e21*(x(1)*c12-x(2)*c21)+e31*
c     &	(x(1)*c13-x(3)*c31)+e41*(x(1)*c14-x(4)*c41)+e51*(x(1)*c15-
c     &	x(5)*c51)+e32*(x(2)*c23-x(3)*c32)+
c     &	e42*(x(2)*c24-x(4)*c42)+e52*(x(2)*c25-x(5)*c52)+
c     &	+e53*(x(3)*c35-x(5)*c53)+
c     &	e54*(x(4)*c45-x(5)*c54))
c
         f345t12=elab*(x(4)*(p41*e41*a41(i)+p42*e42*a42(i))+x(5)*p52
     &  *e52*a52(i)+x(3)*(p31*e31*a31(i)+p32*e32*a32(i)))
         fp345t12=elab*(p41*e41*x(4)*pe41+
     &        p42*e42*x(4)*pe42+
     &        p52*e52*x(5)*pe52+
     &        p31*e31*x(3)*pe31+
     &        p32*e32*x(3)*pe32)
         phextot=phextot+elab*
     &        (p41*e41*(x(1)*pe14-x(4)*pe41)+
     &        p42*e42*(x(2)*pe24-x(4)*pe42)+
     &        p52*e52*(x(2)*pe25-x(5)*pe52)+
     &        p31*e31*(x(1)*pe13-x(3)*pe31)+
     &        p32*e32*(x(2)*pe23-x(3)*pe32))
         phextc=phextc+elab*
     &        (p41*e41*(x(1)*pe14c-x(4)*pe41c)+
     &        p42*e42*(x(2)*pe24c-x(4)*pe42c)+
     &        p52*e52*(x(2)*pe25c-x(5)*pe52c)+
     &        p31*e31*(x(1)*pe13c-x(3)*pe31c)+
     &        p32*e32*(x(2)*pe23c-x(3)*pe32c))
         dphextl=elab*
     &        (p41*e41*(x(1)*pe14l-x(4)*pe41l)+
     &        p42*e42*(x(2)*pe24l-x(4)*pe42l)+
     &        p52*e52*(x(2)*pe25l-x(5)*pe52l)+
     &        p31*e31*(x(1)*pe13l-x(3)*pe31l)+
     &        p32*e32*(x(2)*pe23l-x(3)*pe32l))
c         phextc=phextc+elab*(p41*e41*x(1)*pe14c+
c     &        p42*e42*x(2)*pe24c+
c     &        p52*e52*x(2)*pe25c+
c     &        p31*e31*x(1)*pe13c+
c     &        p32*e32*x(2)*pe23c)
c         dphextl=elab*(p41*e41*x(1)*pe14l+
c     &        p42*e42*x(2)*pe24l+
c     &        p52*e52*x(2)*pe25l+
c     &        p31*e31*x(1)*pe13l+
c     &        p32*e32*x(2)*pe23l)
         phextl=phextl+dphextl
cqcq run 99 
         phexlm(id,k41)=dphextl
c
c not correct
c         t345t12=0.
cnew9802
         x345=x(3)+x(4)+x(5)
         x12=x(1)+x(2)
         g345=g(3)+g(4)+g(5)
         g12=g(1)+g(2)
         a345t21=(a52(i)*x(5)+(a41(i)+a42(i))*x(4)+
     &        (a31(i)+a32(i))*x(3))/x345
c
         t345t12=wl345t12u3*a345t21*g345*deni*x12*(1.-g12*x345
     &        /(g345*x12))*time/(8.*pi*g12)
c
         if (x345.gt.1.e-40) then
            s345t12=(2.*hc/wl345t12u3)/((x12*g345)/(x345*g12)-1)
         else
            s345t12=0.d0
         endif
c
c         fp345t12=elab*(p41*e41*(x(4)*pe41-x(1)*pe14)+
c     &        p42*e42*(x(4)*pe42-x(2)*pe24)+
c     &        p52*e52*(x(5)*pe52-x(2)*pe25)+
c     &        p31*e31*(x(3)*pe31-x(1)*pe13)+
c     &        p32*e32*(x(3)*pe32-x(2)*pe23))
c
         c1=elab*e43*p43
         f43=c1*x(4)*a43(i)
         fp43=c1*x(4)*pe43
         phextot=phextot+c1*(x(3)*pe34-x(4)*pe43)
         phextc=phextc+c1*(x(3)*pe34c-x(4)*pe43c)
         dphextl=c1*(x(3)*pe34l-x(4)*pe43l)
         phextl=phextl+dphextl
cqcq run 99 
         phexlm(id,k43)=dphextl
c
         t43=wl43u3*a43(i)*g(4)*deni*x(3)*(1.-g(3)*x(4)
     &        /(g(4)*x(3)))*time/(8.*pi*g(3))
         if (x(4).gt.1.e-40) then         
            s43=(2.*hc/wl43u3)/((x(3)*g(4))/(x(4)*g(3))-1)
         else
            s43=0.d0
         endif
c
         c1=elab*e54*p54
c
         f54=c1*x(5)*a54(i)
         fp54=c1*x(5)*pe54
c
         phextot=phextot+c1*(x(4)*pe45-x(5)*pe54)
         phextc=phextc+c1*(x(4)*pe45c-x(5)*pe54c)
         dphextl=c1*(x(4)*pe45l-x(5)*pe54l)
         phextl=phextl+dphextl
cqcq run 99 
         phexlm(id,k54)=dphextl
c
         t54=wl54u3*a54(i)*g(5)*deni*x(4)*(1.-g(4)*x(5)
     &        /(g(5)*x(4)))*time/(8.*pi*g(4))
         if (x(5).gt.1.e-40) then
            s54=(2.*hc/wl54u3)/((x(4)*g(5))/(x(5)*g(4))-1)
         else
            s54=0.d0
         endif
c
      else
         co21=elab*(e21*(x(1)*c12-x(2)*c21))
      endif
      cool=co21+co345t12+co43+co54
c
      c1=elab*e21*p21
c
      f21=c1*x(2)*a21(i)
      fp21=c1*x(2)*pe21
c
      phextot=phextot+c1*(x(1)*pe12-x(2)*pe21)
      phextc=phextc+c1*(x(1)*pe12c-x(2)*pe21c)
      dphextl=c1*(x(1)*pe12l-x(2)*pe21l)
      phextl=phextl+dphextl
cqcq run 99 
      phexlm(id,k21)=dphextl
c
      t21=wl21u3*a21(i)*g(2)*deni*x(1)*(1.-g(1)*x(2)
     &     /(g(2)*x(1)))*time/(8.*pi*g(1))
      if (x(2).gt.1.e-40) then
         s21=(2.*hc/wl21u3)/((x(1)*g(2))/(x(2)*g(1))-1)
      else
         s21=0.d0
      endif
c
      phed(j21)=phed(j21)+elab*e21*p21*(x(1)*pe12-x(2)*pe21)
      phed(j31)=phed(j31)+elab*p31*e31*(x(1)*pe13-x(3)*pe31)
      phed(j41)=phed(j41)+elab*p41*e41*(x(1)*pe14-x(4)*pe41)
      phed(j32)=phed(j32)+elab*p32*e32*(x(2)*pe23-x(3)*pe32)
      phed(j42)=phed(j42)+elab*p42*e42*(x(2)*pe24-x(4)*pe42)
      phed(j52)=phed(j52)+elab*p52*e52*(x(2)*pe25-x(5)*pe52)
      phed(j43)=phed(j43)+elab*p43*e43*(x(3)*pe34-x(4)*pe43)
      phed(j54)=phed(j54)+elab*p54*e54*(x(4)*pe45-x(5)*pe54)
c
      endif
C
      RETURN
      END

C*********************************************************************
C*********************************************************************
      subroutine cforb(te,xe,i,abund,f21,f32,f4t123,f5t23,f6t23,f54,
     &fp21,fp32,fp4t123,fp5t23,fp6t23,fp54,
     &t21,t32,t4t123,t5t23,t6t23,t54,
     &s21,s32,s4t123,s5t23,s6t23,s54,
     &wl4t123,wl5t23,wl6t23,
     &co21,co32,co4t123,co5t23,co6t23,co54,cool)
C*********************************************************************
C  Forbidden lines (C I-like). Enumeration of the ions are: (= I)
C  1 = C I   2 = N II   3 = O III   4 = Ne V   5 = S III
C  The atom is treated as a 6-level atom.
C  (Reduced to a 3-level atom for E43/Tev > 20)
c
c Additional data for Ar V, Ca VII, Mg VII, Fe XIII in xforb.f
c
C  Energy levels for O III from Bashkin & Stoner '75 (experimental)
C  Ne V from Lennon & Burke (MNRAS 251, 628; 1991).
C  (Ne V Omegas for fine structure lines may be wrong by up to a factor
C  of 3; Oliva et al. 1996, A&A 305, L21.)
C  Coll.strength of S III, Ar V and Ca VII from Galavis et al. 
C  (AAS, 111, 347, '95.). Ca VII multiplet levels from Nahar & Pradhan
C  (J.Phys.B, 26, 1103, '93.). Fine structure levels from Bashkin & 
C  Stoner ('78). A-values for Ca VII put equal to O III A-values 
C  (which should give a lower limit to the cooling.)
C  S, Ar, Ca & Mg  essentially treated as a 5-level atom. Mg Omegas from
C  Aggarwal (ApJS 56, 303, '84). A-values and level energies from
C  Nussbaumer & Rusca (A&A 72, 129, '79). Fine structure Omegas of Mg VII
C  put equal to those of Ne V. Fe XIII energy levels from Corliss & Sugar
C  ('82) and Fawcett (J.Phys.B. '71). A-values from J.Phys.Chem.Ref. Data
C  ('88), and Omegas from Tayal (ApJ 446, 895, '95). (Omegas are probably
C  valid only for T > 1E5 K.)
C*********************************************************************
      implicit real*8(a-h,o-z)
C
      include 'INCLUDE/PARAM.IOR'
      parameter(itmax=50)
c
      common/ccforb/initc(5),jlc(5,6,6),klc(5,6,6)
      common/cden/den
      common/ctpar/tday,dts,iss,iss1,itd
      common/depthind/id
      common/cmat/a(mmax,mmax),b(mmax)
      common/cebin/e1(ne),en(ne),jmax
      common/cfj/fj(ne),fjidm1(ne),fjc(0:ne),fjcidm1(ne)
      common/cphed/phed(0:ne),phextot,phextc,phextl,phexlm(mid,lmax),
     &     eq1(1200),klq1(1200),kl1m
      common/cscat/fjsc(mid,0:lmax),kksc(lmax),iscv(0:lmax),
     &           is1(lmax),is0(lmax),is2(lmax),iscm,klsc,iflscat
      data pi/3.1415926e0/,tol/0.00001/
c
      dimension ene2(5),ene3(5),ene4(5),ene5(5),ene6(5),a21(5),
     &a31(5),a32(5),a41(5),a42(5),a43(5),a52(5),a53(5),a54(5),
     &a62(5),a63(5),om12(5),om13(5),om23(5),om123t4(5),om23t5(5),
     &om45(5),om23t6(5),al12(5),al13(5),al23(5),al123t4(5),
     &al23t5(5),al45(5),al23t6(5),g(6),ama(5),a0(3,2),a1(3,2),
     &a2(3,2),a3(3,2),a4(3,2),yy(3),x(6)
c
      data ene2/.002033,.006038,.01403,.05113,.03685/
      data ene3/.005381,.01622,.03796,.1376,.1032/
      data ene4/1.2637,1.8989,2.4857,3.7555,1.4035/
      data ene5/2.6839,4.0528,5.3250,7.9240,3.3677/
cold      data ene6/4.1825,5.8004,7.4490,10.9553,7.4014/
cnew 960325
      data ene6/4.1825,5.8004,7.4490,10.9553,7.200/
c
      data a21/7.93d-8,2.08d-6,2.62d-5,1.28d-3,4.72d-4/
      data a31/1.71d-14,1.16d-12,3.02d-11,5.08d-9,4.61d-8/
      data a32/2.65d-7,7.46d-6,9.76d-5,4.59d-3,2.07d-3/
      data a41/7.78d-8,5.35d-7,2.74d-6,2.37d-5,5.82d-6/
      data a42/8.21d-5,1.01d-3,6.74d-3,1.31d-1,2.21d-2/
      data a43/2.44d-4,2.99d-3,1.96d-2,3.65d-1,5.76d-2/
      data a52/2.71d-3,3.38d-2,2.23d-1,4.21d0,7.96d-1/
      data a53/2.00d-5,1.51d-4,7.85d-4,6.69d-3,1.05d-2/
      data a54/5.28d-1,1.12d0,1.78d0,2.85d0,2.22d0/
      data a62/6.94d0,4.8d1,2.12d2,2.37d3,0./
      data a63/1.56d1,1.07d2,5.22d2,6.06d3,0./
cold
c      data om12/0.,0.401,0.542,1.401,2.59/
c      data om13/0.,0.279,0.271,1.766,1.15/
c      data om23/0.,1.13,1.29,5.725,5.81/
c      data om123t4/1.14,2.68,2.29,2.08,8.39/
c      data om23t5/0.252,0.352,0.287,0.242,1.19/
c      data om45/0.277,0.411,0.667,0.518,1.88/
c      data om23t6/0.671,1.28,1.18,1.51,1.d-10/
c      data al12/3*0.,-.328,-.132/,al13/2*0.,.044,-.494,0./
c      data al23/2*0.,.068,-.443,0./,al123t4/.969,0.,.129,.088,-.073/
c      data al23t5/.896,0.,.287,2*0./
c      data al45/.500,.035,.085,.161,.275/,al23t6/.616,0.,.120,2*0./
c
cnew 960325
      data om12/0.,0.401,0.542,1.401,2.33/
      data om13/0.,0.279,0.271,1.766,1.11/
      data om23/0.,1.13,1.29,5.725,5.41/
      data om123t4/1.14,2.68,2.29,2.08,7.95/
      data om23t5/0.252,0.352,0.287,0.242,1.15/
      data om45/0.277,0.411,0.667,0.518,1.30/
      data om23t6/0.671,1.28,1.18,1.51,1.d-10/
      data al12/3*0.,-.328,-.132/
      data al13/2*0.,.044,-.494,0.07/
      data al23/2*0.,.068,-.443,0./
      data al123t4/.969,0.,.129,.088,0./
      data al23t5/.896,0.,.287,2*0./
      data al45/.500,.035,.085,.161,.275/
      data al23t6/.616,0.,.120,2*0./
c
      data a0/-9.25141,-7.69735,-7.4387,444.6,350.609,386.186/
      data a1/-.773782,-1.30743,-.57443,-227.913,-187.474,-202.192/
      data a2/.361184,.697638,.358264,42.5952,36.1803,38.5049/
      data a3/-.0150892,-.111338,-.0418166,-3.4762,-3.03283,-3.19268/
      data a4/-.000656325,-.00705277,-.00235272,.105085,.0938138,
     &.0978573/
      data g/1.,3.,5.,5.,1.,5./
      data ama/12.,14.,16.,20.,32.1/
c hc=h*c=6.626e-27 erg s *2.9979e10 cm/s = 1.9864e-16 erg cm
      data hc/1.9864e-16/
C
      co21=0.d0
      co32=0.d0
      co4t123=0.d0
      co5t23=0.d0
      co6t23=0.d0
      co54=0.d0
c
      cool=0.0d0
      f21=0.0d0
      f32=0.0d0
      f4t123=0.0d0
      f5t23=0.0d0
      f6t23=0.0d0
      f54=0.0d0
      fp21=0.0d0
      fp32=0.0d0
      fp4t123=0.0d0
      fp5t23=0.0d0
      fp6t23=0.0d0
      fp54=0.0d0
      t21=0.0d0
      t32=0.0d0
      t4t123=0.0d0
      t5t23=0.0d0
      t6t23=0.0d0
      t54=0.0d0
      s21=0.0d0
      s32=0.0d0
      s4t123=0.0d0
      s5t23=0.0d0
      s6t23=0.0d0
      s54=0.0d0
      IF (abund.ge.1.d-10) THEN
c
      tev=te/1.1609d4
      t4=te/1.d4
      telog=dlog10(te)
      th=dmax1(telog,3.4d0)
      th=dmin1(5.3d0,th)
      tmx=1.25d5
      time=8.64e4*tday
      deni=den*abund
      dene=den*xe
      cons=8.63d-6*dene/dsqrt(te)
c
      e21=ene2(i)
      e31=ene3(i)
      e41=ene4(i)
      e51=ene5(i)
      e61=ene6(i)
      e32=ene3(i)-ene2(i)
      e42=ene4(i)-ene2(i)
      e52=ene5(i)-ene2(i)
      e62=ene6(i)-ene2(i)
      e43=ene4(i)-ene3(i)
      e53=ene5(i)-ene3(i)
      e63=ene6(i)-ene3(i)
      e54=ene5(i)-ene4(i)
c
      emean=(g(2)*ene2(i)+g(3)*ene3(i))/(g(1)+g(2)+g(3))
c      e5t23=ene5(i)-(g(2)*ene2(i)+g(3)*ene3(i))/(g(1)+g(2))
c      e6t23=ene6(i)-(g(2)*ene2(i)+g(3)*ene3(i))/(g(2)+g(3))
c
      e5t23=ene5(i)-emean
      e6t23=ene6(i)-emean
      e4t123=ene4(i)-emean
c
      if (initc(i).eq.0) then
         do j1=1,jmax
            if(e21.gt.en(j1).and.e21.le.en(j1+1)) then
               jlc(i,2,1)=j1
               jlc(i,1,2)=j1
               goto 91
            endif
         enddo
 91      continue
         do j1=1,jmax
            if(e31.gt.en(j1).and.e31.le.en(j1+1)) then
               jlc(i,3,1)=j1
               jlc(i,1,3)=j1
               goto 92
            endif
         enddo
 92      continue
         do j1=1,jmax
            if(e41.gt.en(j1).and.e41.le.en(j1+1)) then
               jlc(i,4,1)=j1
               jlc(i,1,4)=j1
               goto 93
            endif
         enddo
 93      continue
         do j1=1,jmax
            if(e51.gt.en(j1).and.e51.le.en(j1+1)) then
               jlc(i,5,1)=j1
               jlc(i,1,5)=j1
               goto 94
            endif
         enddo
 94      continue
         do j1=1,jmax
            if(e61.gt.en(j1).and.e61.le.en(j1+1)) then
               jlc(i,6,1)=j1
               jlc(i,1,6)=j1
               goto 88
            endif
         enddo
 88      continue
         do j1=1,jmax
            if(e32.gt.en(j1).and.e32.le.en(j1+1)) then
               jlc(i,3,2)=j1
               jlc(i,2,3)=j1
               goto 95
            endif
         enddo
 95      continue
         do j1=1,jmax
            if(e42.gt.en(j1).and.e42.le.en(j1+1)) then
               jlc(i,4,2)=j1
               jlc(i,2,4)=j1
               goto 96
            endif
         enddo
 96      continue
         do j1=1,jmax
            if(e52.gt.en(j1).and.e52.le.en(j1+1)) then
               jlc(i,5,2)=j1
               jlc(i,2,5)=j1
               goto 97
            endif
         enddo
 97      continue
         do j1=1,jmax
            if(e62.gt.en(j1).and.e62.le.en(j1+1)) then
               jlc(i,6,2)=j1
               jlc(i,2,6)=j1
               goto 87
            endif
         enddo
 87      continue
         do j1=1,jmax
            if(e43.gt.en(j1).and.e43.le.en(j1+1)) then
               jlc(i,4,3)=j1
               jlc(i,3,4)=j1
               goto 98
            endif
         enddo
 98      continue
         do j1=1,jmax
            if(e53.gt.en(j1).and.e53.le.en(j1+1)) then
               jlc(i,5,3)=j1
               jlc(i,3,5)=j1
               goto 99
            endif
         enddo
 99      continue
         do j1=1,jmax
            if(e63.gt.en(j1).and.e63.le.en(j1+1)) then
               jlc(i,6,3)=j1
               jlc(i,3,6)=j1
               goto 86
            endif
         enddo
 86      continue
         do j1=1,jmax
            if(e54.gt.en(j1).and.e54.le.en(j1+1)) then
               jlc(i,5,4)=j1
               jlc(i,4,5)=j1
               goto 89
            endif
         enddo
 89      continue
c
         initc(i)=1
      endif
c
      wl21=12398.54d-8/e21
      wl21u3=wl21**3
      wl31=12398.54d-8/e31
      wl31u3=wl31**3
      wl41=12398.54d-8/e41
      wl41u3=wl41**3
      wl51=12398.54d-8/e51
      wl51u3=wl51**3
      wl61=12398.54d-8/e61
      wl61u3=wl61**3
      wl32=12398.54d-8/e32
      wl32u3=wl32**3
      wl42=12398.54d-8/e42
      wl42u3=wl42**3
      wl52=12398.54d-8/e52
      wl52u3=wl52**3
      wl62=12398.54d-8/e62
      wl62u3=wl62**3
      wl43=12398.54d-8/e43
      wl43u3=wl43**3
      wl53=12398.54d-8/e53
      wl53u3=wl53**3
      wl63=12398.54d-8/e63
      wl63u3=wl63**3
      wl54=12398.54d-8/e54
      wl54u3=wl54**3
c
      wl5t23=12398.54d-8/e5t23
      wl5t23u3=wl5t23**3
      wl6t23=12398.54d-8/e6t23
      wl6t23u3=wl6t23**3
      wl4t123=12398.54d-8/e4t123
c
C  C I from Johnson, Burke & Kingston, J.Phys.B 20, 2553 (1987)
      if(i.eq.1) then
         y=dmin1(dlog(te),9.2103d0)
         ipc=1
         if(te.gt.1.d3) ipc=2
         do ip=1,3
            yy(ip)=a0(ip,ipc)+a1(ip,ipc)*y+a2(ip,ipc)*y**2+
     &  	a3(ip,ipc)*y**3+a4(ip,ipc)*y**4
         enddo
         o12=dexp(yy(1))
         o13=dexp(yy(2))
         o23=dexp(yy(3))
      elseif(i.eq.2) then
         o12=cheb(tmx,te,-1.534d0,0.1436d0,0.0107d0,-0.0076d0)
         o13=cheb(tmx,te,-2.4004d0,0.1962d0,-0.044d0,-0.0296d0)
         o23=cheb(tmx,te,0.4597d0,0.1717d0,-0.0189d0,-0.0198d0)
      else
         o12=om12(i)*t4**al12(i)
         o13=om13(i)*t4**al13(i)
         o23=om23(i)*t4**al23(i)
      endif
      c21=cons*o12/g(2)
      c31=cons*o13/g(3)
      c32=cons*o23/g(3)
      c12=c21*fexp(-e21/tev)*g(2)/g(1)
      c13=c31*fexp(-e31/tev)*g(3)/g(1)
      c23=c32*fexp(-e32/tev)*g(3)/g(2)
      if ((e43/tev).lt.2.d1) then
         gsum=g(1)+g(2)+g(3)
C  O III from Aggarwal, ApJ Suppl. 85, 197 (1993)
C  N II from Stafford et al., MNRAS 268, 816 (1994)
         if(i.eq.3) then
            fc=(g(2)+g(3))/gsum	
            o123t4=35.674-25.2742*th+6.2041*th**2-0.4944*th**3
            o23t5=fc*(5.9018-4.1547*th+1.0034*th**2-0.0788*th**3)
            o23t6=fc*(14.1717-10.5248*th+2.7476*th**2-0.233*th**3)
            o45=42.233-40.2293*th+14.2334*th**2-2.196*th**3+0.125*
     & 		th**4
         elseif(i.eq.2) then
            o14=cheb(tmx,te,-2.1882d0,-0.0023d0,0.0082d0,-0.0005d0)
            o15=cheb(tmx,te,-6.3792d0,-0.0076d0,0.019d0,-0.0013d0)
            o16=cheb(tmx,te,-4.1428d0,-0.0268d0,-0.0218d0,-0.0125d0)
            o24=cheb(tmx,te,0.009d0,-0.0023d0,0.0082d0,-0.0006d0)
            o25=cheb(tmx,te,-4.182d0,-0.0076d0,0.019d0,-0.0013d0)
            o26=cheb(tmx,te,-1.9489d0,-0.0296d0,-0.0239d0,-0.0139d0)
            o34=cheb(tmx,te,1.0307d0,-0.0023d0,0.0082d0,-0.0006d0)
            o35=cheb(tmx,te,-3.1604d0,-0.0076d0,0.019d0,-0.0013d0)
            o36=cheb(tmx,te,-0.9239d0,-0.0268d0,-0.0217d0,-0.0125d0)
            o45=cheb(tmx,te,-1.2463d0,0.0961d0,0.0291d0,-0.0024d0)
         else
            o123t4=om123t4(i)*t4**al123t4(i)
            o23t5=om23t5(i)*t4**al23t5(i)
            o23t6=om23t6(i)*t4**al23t6(i)
            o45=om45(i)*t4**al45(i)
         endif
         if(i.ne.2) then
            o14=g(1)*o123t4/gsum
            o24=g(2)*o14/g(1)
            o34=g(3)*o14/g(1)
            o25=g(2)*o23t5/(g(2)+g(3))
            o15=g(1)*o25/g(2)
            o35=g(3)*o25/g(2)
            o26=g(2)*o23t6/(g(2)+g(3))
            o16=g(1)*o26/g(2)
            o36=g(3)*o26/g(2)
         endif
         c41=cons*o14/g(4)
         c51=cons*o15/g(5)
         c61=cons*o16/g(6)
         c42=cons*o24/g(4)
         c52=cons*o25/g(5)
         c62=cons*o26/g(6)
         c43=cons*o34/g(4)
         c53=cons*o35/g(5)
         c63=cons*o36/g(6)
         c54=cons*o45/g(5)
         c14=c41*fexp(-e41/tev)*g(4)/g(1)
         c15=c51*fexp(-e51/tev)*g(5)/g(1)
         c16=c61*fexp(-e61/tev)*g(6)/g(1)
         c24=c42*fexp(-e42/tev)*g(4)/g(2)
         c25=c52*fexp(-e52/tev)*g(5)/g(2)
         c26=c62*fexp(-e62/tev)*g(6)/g(2)
         c34=c43*fexp(-e43/tev)*g(4)/g(3)
         c35=c53*fexp(-e53/tev)*g(5)/g(3)
         c36=c63*fexp(-e63/tev)*g(6)/g(3)
         c45=c54*fexp(-e54/tev)*g(5)/g(4)
      endif
c
c  Photoexcitation/deexcitation (stimulated) by continuum ...
c
      j21=jlc(i,2,1)
      j31=jlc(i,3,1)
      j41=jlc(i,4,1)
      j51=jlc(i,5,1)
      j61=jlc(i,6,1)
      j32=jlc(i,3,2)
      j42=jlc(i,4,2)
      j52=jlc(i,5,2)
      j62=jlc(i,6,2)
      j43=jlc(i,4,3)
      j53=jlc(i,5,3)
      j63=jlc(i,6,3)
      j54=jlc(i,5,4)
c  ... and by lines
      k21=klc(i,2,1)
      k31=klc(i,3,1)
      k41=klc(i,4,1)
      k51=klc(i,5,1)
      k61=klc(i,6,1)
      k32=klc(i,3,2)
      k42=klc(i,4,2)
      k52=klc(i,5,2)
      k62=klc(i,6,2)
      k43=klc(i,4,3)
      k53=klc(i,5,3)
      k63=klc(i,6,3)
      k54=klc(i,5,4)
c  change the unit from ../eV to ../Hz
c      flc=fjc(j1)/2.41838e14
c      q1=1./(2.41838e14*1.602e-12)
c      pe21=0.5*(wl21*wl21)*a21(i)*flc/(e21*1.602e-12)
c
      fl21=fjc(j21)/2.41838e14
      fl21=fl21+fjsc(id,iscv(k21))
      pe21=0.5*(wl21*wl21)*a21(i)*fl21/(e21*1.602e-12)
      pe12=(g(2)/g(1))*pe21
      if (pe12.gt.0.) then
         frl=fjsc(id,iscv(k21))/fl21
         frc=1.-frl
         pe12c=pe12*frc
         pe21c=pe21*frc
         pe12l=pe12*frl
         pe21l=pe21*frl
      else
         pe12c=0.d0
         pe21c=0.d0
         pe12l=0.d0
         pe21l=0.d0
      endif
c
      fl31=fjc(j31)/2.41838e14
      fl31=fl31+fjsc(id,iscv(k31))
      pe31=0.5*(wl31*wl31)*a31(i)*fl31/(e31*1.602e-12)
      pe13=(g(3)/g(1))*pe31
      if (pe13.gt.0.) then
         frl=fjsc(id,iscv(k31))/fl31
         frc=1.-frl
         pe13c=pe13*frc
         pe31c=pe31*frc
         pe13l=pe13*frl
         pe31l=pe31*frl
      else
         pe13c=0.d0
         pe31c=0.d0
         pe13l=0.d0
         pe31l=0.d0
      endif
c
      fl41=fjc(j41)/2.41838e14
      fl41=fl41+fjsc(id,iscv(k41))
      pe41=0.5*(wl41*wl41)*a41(i)*fl41/(e41*1.602e-12)
      pe14=(g(4)/g(1))*pe41
      if (pe14.gt.0.) then
         frl=fjsc(id,iscv(k41))/fl41
         frc=1.-frl
         pe14c=pe14*frc
         pe41c=pe41*frc
         pe14l=pe14*frl
         pe41l=pe41*frl
      else
         pe14c=0.d0
         pe41c=0.d0
         pe14l=0.d0
         pe41l=0.d0
      endif
c
      fl32=fjc(j32)/2.41838e14
      fl32=fl32+fjsc(id,iscv(k32))
      pe32=0.5*(wl32*wl32)*a32(i)*fl32/(e32*1.602e-12)
      pe23=(g(3)/g(2))*pe32
      if (pe23.gt.0.) then
         frl=fjsc(id,iscv(k32))/fl32
         frc=1.-frl
         pe23c=pe23*frc
         pe32c=pe32*frc
         pe23l=pe23*frl
         pe32l=pe32*frl
      else
         pe23c=0.d0
         pe32c=0.d0
         pe23l=0.d0
         pe32l=0.d0
      endif
c
      fl42=fjc(j42)/2.41838e14
      fl42=fl42+fjsc(id,iscv(k42))
      pe42=0.5*(wl42*wl42)*a42(i)*fl42/(e42*1.602e-12)
      pe24=(g(4)/g(2))*pe42
      if (pe24.gt.0.) then
         frl=fjsc(id,iscv(k42))/fl42
         frc=1.-frl
         pe24c=pe24*frc
         pe42c=pe42*frc
         pe24l=pe24*frl
         pe42l=pe42*frl
      else
         pe24c=0.d0
         pe42c=0.d0
         pe24l=0.d0
         pe42l=0.d0
      endif
c
      fl52=fjc(j52)/2.41838e14
      fl52=fl52+fjsc(id,iscv(k52))
      pe52=0.5*(wl52*wl52)*a52(i)*fl52/(e52*1.602e-12)
      pe25=(g(5)/g(2))*pe52
      if (pe25.gt.0.) then
         frl=fjsc(id,iscv(k52))/fl52
         frc=1.-frl
         pe25c=pe25*frc
         pe52c=pe52*frc
         pe25l=pe25*frl
         pe52l=pe52*frl
      else
         pe25c=0.d0
         pe52c=0.d0
         pe25l=0.d0
         pe52l=0.d0
      endif
c
      fl62=fjc(j62)/2.41838e14
      fl62=fl62+fjsc(id,iscv(k62))
      pe62=0.5*(wl62*wl62)*a62(i)*fl62/(e62*1.602e-12)
      pe26=(g(6)/g(2))*pe62
      if (pe26.gt.0.) then
         frl=fjsc(id,iscv(k62))/fl62
         frc=1.-frl
         pe26c=pe26*frc
         pe62c=pe62*frc
         pe26l=pe26*frl
         pe62l=pe62*frl
      else
         pe26c=0.d0
         pe62c=0.d0
         pe26l=0.d0
         pe62l=0.d0
      endif
c
      fl43=fjc(j43)/2.41838e14
      fl43=fl43+fjsc(id,iscv(k43))
      pe43=0.5*(wl43*wl43)*a43(i)*fl43/(e43*1.602e-12)
      pe34=(g(4)/g(3))*pe43
      if (pe34.gt.0.) then
         frl=fjsc(id,iscv(k43))/fl43
         frc=1.-frl
         pe34c=pe34*frc
         pe43c=pe43*frc
         pe34l=pe34*frl
         pe43l=pe43*frl
      else
         pe34c=0.d0
         pe43c=0.d0
         pe34l=0.d0
         pe43l=0.d0
      endif
c
      fl53=fjc(j53)/2.41838e14
      fl53=fl53+fjsc(id,iscv(k53))
      pe53=0.5*(wl53*wl53)*a53(i)*fl53/(e53*1.602e-12)
      pe35=(g(5)/g(3))*pe53
      if (pe35.gt.0.) then
         frl=fjsc(id,iscv(k53))/fl53
         frc=1.-frl
         pe35c=pe35*frc
         pe53c=pe53*frc
         pe35l=pe35*frl
         pe53l=pe53*frl
      else
         pe35c=0.d0
         pe53c=0.d0
         pe35l=0.d0
         pe53l=0.d0
      endif
c
      fl63=fjc(j63)/2.41838e14
      fl63=fl63+fjsc(id,iscv(k63))
      pe63=0.5*(wl63*wl63)*a63(i)*fl63/(e63*1.602e-12)
      pe36=(g(6)/g(3))*pe63
      if (pe36.gt.0.) then
         frl=fjsc(id,iscv(k63))/fl63
         frc=1.-frl
         pe36c=pe36*frc
         pe63c=pe63*frc
         pe36l=pe36*frl
         pe63l=pe63*frl
      else
         pe36c=0.d0
         pe63c=0.d0
         pe36l=0.d0
         pe63l=0.d0
      endif
c
      fl54=fjc(j54)/2.41838e14
      fl54=fl54+fjsc(id,iscv(k54))
      pe54=0.5*(wl54*wl54)*a54(i)*fl54/(e54*1.602e-12)
      pe45=(g(5)/g(4))*pe54
      if (pe45.gt.0.) then
         frl=fjsc(id,iscv(k54))/fl54
         frc=1.-frl
         pe45c=pe45*frc
         pe54c=pe54*frc
         pe45l=pe45*frl
         pe54l=pe54*frl
      else
         pe45c=0.d0
         pe54c=0.d0
         pe45l=0.d0
         pe54l=0.d0
      endif
c
c  start-values
      x(1)=1.0
      do j=2,6
	x(j)=1.d-10
      enddo
c
      do it=1,itmax
c
c calculate the escape probability : p21,p31,p32
c p21
         t0=wl21u3*a21(i)*g(2)*deni*x(1)*(1.-g(1)*x(2)
     &		/(g(2)*x(1)))*time/(8.*pi*g(1))
         if (t0.lt.0.01) then
            p21=1.-0.5*t0+(t0**2)/6.
         elseif(t0.ge.0.01) then
            p21=(1.-fexp(-t0))/t0
         endif
c p31
         t0=wl31u3*a31(i)*g(3)*deni*x(1)*(1.-g(1)*x(3)
     &		/(g(3)*x(1)))*time/(8.*pi*g(1))
         if (t0.lt.0.01) then
            p31=1.-0.5*t0+(t0**2)/6.
         elseif(t0.ge.0.01) then
            p31=(1.-fexp(-t0))/t0
         endif
c p32
         t0=wl32u3*a32(i)*g(3)*deni*x(2)*(1.-g(2)*x(3)
     &		/(g(3)*x(2)))*time/(8.*pi*g(2))
         if (t0.lt.0.01) then
            p32=1.-0.5*t0+(t0**2)/6.
         elseif(t0.ge.0.01) then
            p32=(1.-fexp(-t0))/t0
         endif
c
         if((e43/tev).lt.2.d1) then
c calculate the escape probability : p41,p42,p52,p43,p53,p54,p62,p63
c p41
            t0=wl41u3*a41(i)*g(4)*deni*x(1)*(1.-g(1)*x(4)
     &		/(g(4)*x(1)))*time/(8.*pi*g(1))
            if (t0.lt.0.01) then
               p41=1.-0.5*t0+(t0**2)/6.
            elseif(t0.ge.0.01) then
               p41=(1.-fexp(-t0))/t0
            endif
c p42
            t0=wl42u3*a42(i)*g(4)*deni*x(2)*(1.-g(2)*x(4)
     &		/(g(4)*x(2)))*time/(8.*pi*g(2))
            if (t0.lt.0.01) then
               p42=1.-0.5*t0+(t0**2)/6.
            elseif(t0.ge.0.01) then
               p42=(1.-fexp(-t0))/t0
            endif
c p43
            t0=wl43u3*a43(i)*g(4)*deni*x(3)*(1.-g(3)*x(4)
     &		/(g(4)*x(3)))*time/(8.*pi*g(3))
            if (t0.lt.0.01) then
               p43=1.-0.5*t0+(t0**2)/6.
            elseif(t0.ge.0.01) then
               p43=(1.-fexp(-t0))/t0
            endif
c p52
            t0=wl52u3*a52(i)*g(5)*deni*x(2)*(1.-g(2)*x(5)
     &		/(g(5)*x(2)))*time/(8.*pi*g(2))
            if (t0.lt.0.01) then
               p52=1.-0.5*t0+(t0**2)/6.
            elseif(t0.ge.0.01) then
               p52=(1.-fexp(-t0))/t0
            endif
c p53
            t0=wl53u3*a53(i)*g(5)*deni*x(3)*(1.-g(3)*x(5)
     &		/(g(5)*x(3)))*time/(8.*pi*g(3))
            if (t0.lt.0.01) then
               p53=1.-0.5*t0+(t0**2)/6.
            elseif(t0.ge.0.01) then
               p53=(1.-fexp(-t0))/t0
            endif
c p54
            t0=wl54u3*a54(i)*g(5)*deni*x(4)*(1.-g(4)*x(5)
     &		/(g(5)*x(4)))*time/(8.*pi*g(4))
            if (t0.lt.0.01) then
               p54=1.-0.5*t0+(t0**2)/6.
            elseif(t0.ge.0.01) then
               p54=(1.-fexp(-t0))/t0
            endif
c p62
            t0=wl62u3*a62(i)*g(6)*deni*x(2)*(1.-g(2)*x(6)
     &		/(g(6)*x(2)))*time/(8.*pi*g(2))
            if (t0.lt.0.01) then
               p62=1.-0.5*t0+(t0**2)/6.
            elseif(t0.ge.0.01) then
               p62=(1.-fexp(-t0))/t0
            endif
c p63
            t0=wl63u3*a63(i)*g(6)*deni*x(3)*(1.-g(3)*x(6)
     &		/(g(6)*x(3)))*time/(8.*pi*g(3))
            if (t0.lt.0.01) then
               p63=1.-0.5*t0+(t0**2)/6.
            elseif(t0.ge.0.01) then
               p63=(1.-fexp(-t0))/t0
            endif
c
            a(1,1)=c12+c13+c14+c15+c16
            a(1,1)=a(1,1)+pe12*p21+pe13*p31+pe14*p41
            a(1,2)=-(c21+p21*(a21(i)+pe21))
            a(1,3)=-(c31+p31*(a31(i)+pe31))
            a(1,4)=-(c41+p41*(a41(i)+pe41))
            a(1,5)=-c51
            a(1,6)=-c61
            a(2,1)=-c12-pe12*p21
            a(2,2)=c21+c23+c24+c25+c26+p21*a21(i)
            a(2,2)=a(2,2)+pe21*p21+pe23*p32+pe24*p42+
     &           pe25*p52+pe26*p62
            a(2,3)=-(c32+p32*(a32(i)+pe32))
            a(2,4)=-(c42+p42*(a42(i)+pe42))
            a(2,5)=-(c52+p52*(a52(i)+pe52))
            a(2,6)=-(c62+p62*(a62(i)+pe62))
            do j=1,6
               b(j)=0.d0
               a(3,j)=1.d0
            enddo
            b(3)=1.d0
            a(4,1)=-c14-pe14*p41
            a(4,2)=-c24-pe24*p42
            a(4,3)=-c34-pe34*p43
            a(4,4)=c41+c42+c43+c45+p41*(a41(i)+pe41)+
     &           p42*(a42(i)+pe42)+p43*(a43(i)+pe43)+pe45*p54
            a(4,5)=-(c54+p54*(a54(i)+pe54))
            a(4,6)=0.0d0
            a(5,1)=-c15
            a(5,2)=-c25-pe25*p52
            a(5,3)=-c35-pe35*p53
            a(5,4)=-c45-pe45*p54
            a(5,5)=c51+c52+c53+c54+p52*(a52(i)+pe52)+
     &           p53*(a53(i)+pe53)+p54*(a54(i)+pe54)
            a(5,6)=0.0d0
            a(6,1)=-c16
            a(6,2)=-c26-pe26*p62
            a(6,3)=-c36-pe36*p63
            a(6,4)=0.0d0
            a(6,5)=0.0d0
            a(6,6)=c61+c62+c63+p62*(a62(i)+pe62)+p63*(a63(i)+pe63)
c
            call matrixb(6,7)
c
            dxmax=0.
            do j=1,6
               dx=abs((b(j)-x(j))/b(j))
               if (dx.gt.dxmax) dxmax=dx
               x(j)=b(j)
            enddo
         else 
            a(1,1)=c12+c13+pe12*p21+pe13*p31
            a(1,2)=-(c21+p21*(a21(i)+pe21))
            a(1,3)=-(c31+p31*(a31(i)+pe31))
            a(2,1)=-c12-pe12*p21
            a(2,2)=c21+c23+p21*(a21(i)+pe21)+pe23*p32
            a(2,3)=-(c32+p32*(a32(i)+pe32))
            a(3,1)=1.d0
            a(3,2)=1.d0
            a(3,3)=1.d0
            b(1)=0.0d0
            b(2)=0.0d0
            b(3)=1.d0
c
            call matrixb(3,7)
c
            dxmax=0.
            do j=1,3
               dx=abs((b(j)-x(j))/b(j))
               if (dx.gt.dxmax) dxmax=dx
               x(j)=b(j)
            enddo
c
         endif
         if(dxmax.lt.tol) goto 9988
      enddo
      if (it.ge.itmax) write(50,701) 'cforb : no conv!',i,tday,abund,id
9988  continue
 701  format(a,i5,f10.2,1pe12.4,i5)
c
      elab=(1.6022d-12*abund)/dene
      if((e43/tev).lt.2.d1) then
         co21=elab*(e21*(x(1)*c12-x(2)*c21))
         co32=elab*(e32*(x(2)*c23-x(3)*c32))
         co4t123=elab*(e41*(x(1)*c14-x(4)*c41)+
     &        e42*(x(2)*c24-x(4)*c42)+e43*(x(3)*c34-x(4)*c43))
         co5t23=elab*(e52*(x(2)*c25-x(5)*c52)+
     &        e53*(x(3)*c35-x(5)*c53))
         co6t23=elab*(e62*(x(2)*c26-x(6)*c62)+
     &        e63*(x(3)*c36-x(6)*c63))
         co54=elab*(e54*(x(4)*c45-x(5)*c54))
c
         coolx=elab*(e31*(x(1)*c13-x(3)*c31)+e51*
     &        (x(1)*c15-x(5)*c51)+e61*(x(1)*c16-x(6)*c61))
c
c         cool=elab*(e21*(x(1)*c12-x(2)*c21)+e31*
c     &	(x(1)*c13-x(3)*c31)+e41*(x(1)*c14-x(4)*c41)+e51*(x(1)*c15-
c     &	x(5)*c51)+e61*(x(1)*c16-x(6)*c61)+e32*(x(2)*c23-x(3)*c32)+
c     &	e42*(x(2)*c24-x(4)*c42)+e52*(x(2)*c25-x(5)*c52)+e62*(x(2)*
c     &	c26-x(6)*c62)+e43*(x(3)*c34-x(4)*c43)+e53*(x(3)*c35-x(5)*
c     &	c53)+e63*(x(3)*c36-x(6)*c63)+e54*(x(4)*c45-x(5)*c54))
c
         f4t123=elab*x(4)*(p41*e41*a41(i)+p42*e42*a42(i)+p43*e43*a43(i))
         fp4t123=elab*p41*e41*(x(4)*pe41+
     &        p42*e42*x(4)*pe42+
     &        p43*e43*x(4)*pe43)
         phextot=phextot+elab*
     &        (p41*e41*(x(1)*pe14-x(4)*pe41)+
     &        p42*e42*(x(2)*pe24-x(4)*pe42)+
     &        p43*e43*(x(3)*pe34-x(4)*pe43))
         phextc=phextc+elab*
     &        (p41*e41*(x(1)*pe14c-x(4)*pe41c)+
     &        p42*e42*(x(2)*pe24c-x(4)*pe42c)+
     &        p43*e43*(x(3)*pe34c-x(4)*pe43c))
c     &        (p41*e41*x(1)*pe14c+
c     &        p42*e42*x(2)*pe24c+
c     &        p43*e43*x(3)*pe34c)
         dphextl=elab*
     &        (p41*e41*(x(1)*pe14l-x(4)*pe41l)+
     &        p42*e42*(x(2)*pe24l-x(4)*pe42l)+
     &        p43*e43*(x(3)*pe34l-x(4)*pe43l))
c     &        (p41*e41*x(1)*pe14l+
c     &        p42*e42*x(2)*pe24l+
c     &        p43*e43*x(3)*pe34l)
         phextl=phextl+dphextl
cqcq run 99 
         phexlm(id,k41)=dphextl
c
         gl=g(1)+g(2)+g(3)
         gu=g(4)
         el=(g(2)*e21+g(3)*e31)/gl
         eu=e41
         wlul=12398.54d-8/(eu-el)
         wlulu3=wlul**3.
         aul=wl41u3*a41(i)+wl42u3*a42(i)+wl43u3*a43(i)/
     & wlulu3
         xl=x(1)+x(2)+x(3)
         xu=x(4)
         t4t123=wlulu3*aul*gu*deni*xl*(1.-gl*xu
     &		/(gu*xl))*time/(8.*pi*gl)
         if (xu.gt.1.e-40) then         
            s4t123=(2.*hc/wlulu3)/((xl*gu)/(xu*gl)-1)
         else
            s4t123=0.d0
         endif
c
c         fp4t123=elab*(p41*e41*(x(4)*pe41-x(1)*pe14)+
c     &        p42*e42*(x(4)*pe42-x(2)*pe24)+
c     &        p43*e43*(x(4)*pe43-x(3)*pe34))
         f5t23=elab*x(5)*(p52*e52*a52(i)+p53*e53*a53(i))
         fp5t23=elab*(p52*e52*x(5)*pe52+
     &        p53*e53*x(5)*pe53)
         phextot=phextot+elab*
     &        (p52*e52*(x(2)*pe25-x(5)*pe52)+
     &        p53*e53*(x(3)*pe35-x(5)*pe53))
         phextc=phextc+elab*
     &        (p52*e52*(x(2)*pe25c-x(5)*pe52c)+
     &        p53*e53*(x(3)*pe35c-x(5)*pe53c))
c     &        (p52*e52*x(2)*pe25c+
c     &        p53*e53*x(3)*pe35c)
         dphextl=elab*
     &        (p52*e52*(x(2)*pe25l-x(5)*pe52l)+
     &        p53*e53*(x(3)*pe35l-x(5)*pe53l))
c     &        (p52*e52*x(2)*pe25l+
c     &        p53*e53*x(3)*pe35l)
         phextl=phextl+dphextl
cqcq run 99 
         phexlm(id,k52)=dphextl
c
c not correct
c         t5t23=0.
cnew9802
         g23=g(2)+g(3)
         x23=x(2)+x(3)
         a5t23=a52(i)+a53(i)
         t5t23=wl5t23u3*a5t23*g(5)*deni*x23*(1.-g23*x(5)
     &        /(g(5)*x23))*time/(8.*pi*g23)
c
         if (x(5).gt.1.e-40) then         
            s5t23=(2.*hc/wl5t23u3)/((x23*g(5))/(x(5)*g23)-1)
         else
            s5t23=0.d0
         endif
c
c         fp5t23=elab*(p52*e52*(x(5)*pe52-x(2)*pe25)+
c     &        p53*e53*(x(5)*pe53-x(3)*pe35))
         f6t23=elab*x(6)*(p62*e62*a62(i)+p63*e63*a63(i))
         fp6t23=elab*(p62*e62*x(6)*pe62+
     &        p63*e63*x(6)*pe63)
         phextot=phextot+elab*
     &        (p62*e62*(x(2)*pe26-x(6)*pe62)+
     &        p63*e63*(x(3)*pe36-x(6)*pe63))
         phextc=phextc+elab*
     &        (p62*e62*(x(2)*pe26c-x(6)*pe62c)+
     &        p63*e63*(x(3)*pe36c-x(6)*pe63c))
c     &        (p62*e62*x(2)*pe26c+
c     &        p63*e63*x(3)*pe36c)
         dphextl=elab*
     &        (p62*e62*(x(2)*pe26l-x(6)*pe62l)+
     &        p63*e63*(x(3)*pe36l-x(6)*pe63l))
c     &        (p62*e62*x(2)*pe26l+
c     &        p63*e63*x(3)*pe36l)
         phextl=phextl+dphextl
cqcq run 99 
         phexlm(id,k62)=dphextl
c
c not correct
c         t6t23=0.
cnew9802
         g23=g(2)+g(3)
         x23=x(2)+x(3)
         a6t23=a62(i)+a63(i)
         t6t23=wl6t23u3*a6t23*g(6)*deni*x23*(1.-g23*x(6)
     &        /(g(6)*x23))*time/(8.*pi*g23)
         if (x(6).gt.1.e-40) then         
            s6t23=(2.*hc/wl6t23u3)/((x23*g(6))/(x(6)*g23)-1)
         else
            s6t23=0.d0
         endif
c
         c1=elab*e54*p54
c
c         fp6t23=elab*(p62*e62*(x(6)*pe62-x(2)*pe26)+
c     &        p63*e63*(x(6)*pe63-x(3)*pe36))
         f54=c1*x(5)*a54(i)
         fp54=c1*x(5)*pe54
         phextot=phextot+c1*(x(4)*pe45-x(5)*pe54)
         phextc=phextc+c1*(x(4)*pe45c-x(5)*pe54c)
         dphextl=c1*(x(4)*pe45l-x(5)*pe54l)
         phextl=phextl+dphextl
cqcq run 99 
         phexlm(id,k54)=dphextl
c
         t54=wl54u3*a54(i)*g(5)*deni*x(4)*(1.-g(4)*x(5)
     &        /(g(5)*x(4)))*time/(8.*pi*g(4))
         if (x(5).gt.1.e-40) then         
            s54=(2.*hc/wl54u3)/((x(4)*g(5))/(x(5)*g(4))-1)
         else
            s54=0.d0
         endif
c
      else
         co21=elab*(e21*(x(1)*c12-x(2)*c21))
         co32=elab*(e32*(x(2)*c23-x(3)*c32))
         coolx=0.d0
      endif
c
      cool=co21+co32+co4t123+co5t23+co6t23+co54+coolx
c
      c1=elab*e21*p21
      f21=c1*x(2)*a21(i)
      fp21=c1*x(2)*pe21
      phextot=phextot+c1*(x(1)*pe12-x(2)*pe21)
      phextc=phextc+c1*(x(1)*pe12c-x(2)*pe21c)
      dphextl=c1*(x(1)*pe12l-x(2)*pe21l)
      phextl=phextl+dphextl
cqcq run 99 
      phexlm(id,k21)=dphextl
c
      t21=wl21u3*a21(i)*g(2)*deni*x(1)*(1.-g(1)*x(2)
     &     /(g(2)*x(1)))*time/(8.*pi*g(1))
      if (x(2).gt.1.e-40) then
         s21=(2.*hc/wl21u3)/((x(1)*g(2))/(x(2)*g(1))-1)
      else
         s21=0.d0
      endif
c
      c1=elab*e32*p32
      f32=c1*x(3)*a32(i)
      fp32=c1*x(3)*pe32
      phextot=phextot+c1*(x(2)*pe23-x(3)*pe32)
      phextc=phextc+c1*(x(2)*pe23c-x(3)*pe32c)
      dphextl=c1*(x(2)*pe23l-x(3)*pe32l)
      phextl=phextl+dphextl
cqcq run 99 
      phexlm(id,k32)=dphextl
c
      t32=wl32u3*a32(i)*g(3)*deni*x(2)*(1.-g(2)*x(3)
     &     /(g(3)*x(2)))*time/(8.*pi*g(2))      
      if (x(3).gt.1.e-40) then
         s32=(2.*hc/wl32u3)/((x(2)*g(3))/(x(3)*g(2))-1)
      else
         s32=0.d0
      endif
c
      phed(j21)=phed(j21)+elab*p21*e21*(x(1)*pe12-x(2)*pe21)
c      phed(j31)=phed(j31)+elab*p31*e31*x(1)*pe13
      phed(j41)=phed(j41)+elab*p41*e41*(x(1)*pe14-x(4)*pe41)
      phed(j32)=phed(j32)+elab*p32*e32*(x(2)*pe23-x(3)*pe32)
      phed(j42)=phed(j42)+elab*p42*e42*(x(2)*pe24-x(4)*pe42)
      phed(j52)=phed(j52)+elab*p52*e52*(x(2)*pe25-x(5)*pe52)
      phed(j62)=phed(j62)+elab*p62*e62*(x(2)*pe26-x(6)*pe62)
      phed(j43)=phed(j43)+elab*p43*e43*(x(3)*pe34-x(4)*pe43)
      phed(j53)=phed(j53)+elab*p53*e53*(x(3)*pe35-x(5)*pe53)
      phed(j63)=phed(j63)+elab*p63*e63*(x(3)*pe36-x(6)*pe63)
      phed(j54)=phed(j54)+elab*p54*e54*(x(4)*pe45-x(5)*pe54)
c
      ENDIF
C
      return
      end


C*********************************************************************
C*********************************************************************
      subroutine nforb(te,xe,i,abund,f23t1,f45t1,f45t23,
     &fp23t1,fp45t1,fp45t23,t23t1,t45t1,t45t23,
     &s23t1,s45t1,s45t23,
     &wl23t1,wl45t1,wl45t23,
     &co23t1,co45t1,co45t23,cool)
C*********************************************************************
C  Forbidden lines (N I-like). Enumeration of the ions are: (= I)
c
C  1 = N I  2 = O II  3 = Ne IV  4 = S II  5 = Na V  6 = Ar IV
C  7 = Mg VI  8 = Si VIII
c
C  The atom is treated as a 5-level atom.
C  No levels are calculated if E21/TEV > 20, except for o ii that
c  is always calculated.
c
c  NEW DATA 960325 :
C  Note that some of the levels have inverted energy levels !
C  N I Omegas from Mendoza ('83) and A-values from Kaufman & Sugar (J.Phys.
C  Chem. '86). O II, Ne IV & Ar IV from Osterbrock ('89). 
C  O II & Ne IV checked against the original papers, and small changes
C  may occur. O II Omegas updated with McLaughlin & Bell (J.Phys.B '93).
C  New A-values for S II (Keenan et al., Phys. Scripta 48, 129 (1993). 
C  S II (Omegas) updated with Ramsbottom, Bell & Stafford (1996) [Different
C  from Cai & Pradhan, ApjS 88, 329 (1993)]. 
C  Na V from Mendoza ('83). A-values, energies and 10Ryd-Omegas for 
C  Mg VI and Si VIII from Bhatia & Manson (MNRAS 190, 925, '80).
C  (From isoel.scaling this actually gives rather good Omegas.)
c
ck : non-thermal ionization of O I to the excited levels in O II included
c
c New 990830: 
c  -   Neon (Ne IV) from Pradhan & Peng:
c      Atomic Data For The Analysis of Emission Lines 
c      By Anil K. Pradhan and Jianfang Peng 
c     "The Analysis of Emission Lines", Space Telescope Science 
c      Institute Symposium Series No. 8, Ed: R.E.Williams and 
c      M.Livio, Cambridge University Press (1995). 
c
c  -   Include the following ions : Na V,Ar IV,Mg VI,Si VIII
c
c  -   Ar IV : Omegas from Ramsbottom, Bell & Keenan 1997, MNRAS, 284, 754
c  -   Ar IV : A-values from Pradhan & Peng, 1995
c************************************************************************
c
c  (Old data not used :
C  Note that some of the levels have inverted energy levels !
C  (Mainly Mendoza '83. O II updated with McLaughlin & Bell, J.Phys.B '93).
C  New A-values for S II (Keenan et al., Phys. Scripta 48, 129 (1993)).
C  S II (Omegas) updated with Cai & Pradhan, ApjS 88, 329 (1993).)
c
C*********************************************************************
      implicit real*8(a-h,o-z)
      logical ok
C
      include 'INCLUDE/PARAM.IOR'
      parameter(itmax=50)
c
      common/cnforb/initn(8),jln(8,5,5),kln(8,5,5)
      common/cden/den
      common/ctpar/tday,dts,iss,iss1,itd
      common/depthind/id
      common/gampar/gaelh,gahe
      common/cfrsf/frhe(mid),fiei(mid,mie,mion),feeihi(mid,nmax),
     &     feeihei(mid,nl),feeioi(mid,nl),feeicaii(mid,nl),
     &     feeinai(mid,nl),feeimgi(mid,nl),feeimgii(mid,nl),
     &     feeisi1(mid,nl),
     &     feeifei(mid,nlf1),feeifeii(mid,nlf2),fio(mid,4)
c     &     fieoii2d,fieoii2p
      common/cmat/a(mmax,mmax),b(mmax)
      common/cebin/e1(ne),en(ne),jmax
      common/cfj/fj(ne),fjidm1(ne),fjc(0:ne),fjcidm1(ne)
      common/cphed/phed(0:ne),phextot,phextc,phextl,phexlm(mid,lmax),
     &     eq1(1200),klq1(1200),kl1m
      data pi/3.1415926e0/,tol/0.00001/,elch/1.60219d-12/
      common/robcum/fro21,fro41,frs21,frs41,frr21,frr41
      common/cscat/fjsc(mid,0:lmax),kksc(lmax),iscv(0:lmax),
     &           is1(lmax),is0(lmax),is2(lmax),iscm,klsc,iflscat
c
      dimension ene2(8),ene3(8),ene4(8),ene5(8),a21(8),a31(8),
     &a32(8),a41(8),a42(8),a43(8),a51(8),a52(8),a53(8),a54(8),
     &om12(8),om13(8),om14(8),om15(8),om23(8),om24(8),om25(8),
     &om34(8),om35(8),om45(8),al12(8),al13(8),al14(8),al15(8),
     &al23(8),al24(8),al25(8),al34(8),al35(8),al45(8),g(5),
     &x(5),ama(8)
c
      data ene2/2.381916,3.321846,5.108967,1.840287,5.9860,
     &2.6131,7.2166,8.9326/
      data ene3/2.382994,3.324262,5.114530,1.844227,5.9917,
     &2.6291,7.2171,8.9725/
      data ene4/3.573140,5.013923,7.735647,3.038635,9.0697,
     &4.3186,10.233,12.878/
      data ene5/3.573189,5.014060,7.736477,3.044446,9.0740,
     &4.3405,10.243,12.943/
c
c new data 960325 for i=2 (o ii)
cold  a21=3.82d-5, a31=1.65d-4, a41=5.64d-2, a51=2.32d-2
cnew  a21=3.54d-5, a31=1.80d-4, a41=5.75d-2, a51=2.36d-2
cold  a32=1.20d-7, a42=1.17d-1, a52=6.15d-2
cnew  a32=1.31d-7, a42=1.07d-1, a52=5.63d-2
cold  a43=6.14d-2, a53=1.02d-1, a54=2.08d-11
cnew  a43=5.79d-2, a53=9.40d-2, a54=1.35d-10
c
c new Ne IV data 990830 from Pradhan & Peng 
cold      data a21/7.27d-6,3.54d-5,4.84d-4,8.9d-4/
cold      data a31/2.02d-5,1.80d-4,5.54d-3,2.73d-4/
cold      data a41/2.71d-3,5.75d-2,5.21d-1,9.06d-2/
cold      data a51/6.58d-3,2.36d-2,1.27d0,2.25d-1/
cold      data a32/1.27d-8,1.31d-7,1.48d-6,3.35d-7/
cold      data a42/3.45d-2,1.07d-1,1.15d-1,1.41d-1/
cold      data a52/6.14d-2,5.63d-2,4.00d-1,1.21d-1/
cold      data a43/5.29d-2,5.79d-2,3.93d-1,6.27d-2/
cold      data a53/2.76d-2,9.40d-2,4.37d-1,1.52d-1/
cold      data a54/0.,1.35d-10,2.68d-9,1.03d-6/
cold      data om13/.194,.55,.559,4.19/,om12/.290,.825,.838,2.79/
cold      data om14/.0567,.276,.156,.759/,om15/.113,.138,.313,1.52/
cold      data om23/.269,1.17,1.36,7.59/,om24/.109,.882,.368,1.52/
cold      data om25/.266,.356,.900,3.38/,om34/.097,.493,.336,2.56/
cold      data om35/.147,.332,.509,4.79/,om45/.071,.287,.343,2.38/
cold      data al12/1.153,.038,0.,-.095/,al13/1.154,.038,0.,-.095/
cold      data al14/1.191,.0738,2*0./,al15/1.190,.0738,2*0./,
cold     &al23/.931,2*0.,-.140/
cold      data al24/.801,.1357,.054,0./,al25/.717,.1357,2*0./,
cold     &al34/.693,.1357,2*0./
cold      data al35/.779,.1357,2*0./,al45/1.109,.049,.109,0./
c
c New omegas for Ar IV from Ramsbottom et al 1997
c
cold      data om12/.290,.825,.838,2.76,.551,1.30,.19,.15/
cold      data om13/.194,.55,.559,4.14,.368,1.94,.22,.18/
cold      data om14/.0567,.276,.156,1.17,.12,.147,.058,.048/
cold      data om15/.113,.138,.313,2.35,.239,.293,.10,.084/
cold      data om23/.269,1.17,1.36,7.47,.696,6.13,.28,.22/
cold      data om24/.109,.882,.368,1.79,.201,1.67,.15,.10/
cold      data om25/.266,.356,.900,3.00,.502,2.47,.19,.13/
cold      data om34/.097,.493,.336,2.20,.19,1.79,.14,.10/
cold      data om35/.147,.332,.509,4.99,.279,4.44,.37,.26/
cold      data om45/.071,.287,.343,2.71,.438,2.33,.15,.12/
cold      data al12/.904,.038,0.,-.161,4*0./
cold      data al13/.913,.038,0.,-.160,4*0./
cold      data al14/.928,.0738,0.,-.104,4*0./
cold      data al15/.921,.0738,0.,-.101,4*0./
cold      data al23/1.07,2*0.,-.135,4*0./
cold      data al24/.800,.1357,.054,-.153,4*0./
cold      data al25/.715,.1357,0.,-.120,4*0./
cold      data al34/.691,.1357,0.,-.115,4*0./
cold      data al35/.780,.1357,0.,-.141,4*0./
cold      data al45/1.110,.049,.109,-.158,4*0./
c
      data a21/6.92d-6,3.54d-5,4.58d-4,8.9d-4,1.46d-3,2.23d-2,
     &0.145d0,1.96d0/
      data a31/1.62d-5,1.80d-4,5.77d-3,2.73d-4,2.69d-2,1.77d-3,
     &3.11d-3,3.75d-2/
      data a41/2.46d-3,5.75d-2,5.21d-1,9.06d-2,1.76d0,8.62d-1,
     &4.92d0,29.9d0/
      data a51/6.18d-3,2.36d-2,1.27d0,2.25d-1,4.27d0,2.11d0,
     &12.d0,71.2d0/
      data a32/1.07d-8,1.31d-7,1.46d-6,3.35d-7,1.55d-6,2.3d-5,
     &3.5d-5,3.54d-4/
      data a42/3.45d-2,1.07d-1,1.15d-2,1.41d-1,1.41d-1,6.03d-1,
     &1.85d0,11.4d0/
      data a52/5.48d-2,5.63d-2,3.88d-1,1.21d-1,9.18d-1,7.89d-1,
     &2.99d0,19.d0/
      data a43/4.71d-2,5.79d-2,3.93d-1,6.27d-2,9.55d-1,1.19d-1,
     &7.67d-2,0.119d0/
      data a53/2.47d-2,9.40d-2,4.37d-1,1.52d-1,1.29d0,5.98d-1,
     &1.69d0,10.5d0/
      data a54/5.17d-13,1.35d-10,2.82d-9,1.03d-6,3.64d-7,
     &4.94d-5,4.36d-6,1.29d-3/
c
      data om12/.290,.825,.838,2.76,.551,1.144,.19,.15/
      data om13/.194,.55,.559,4.14,.368,0.762,.22,.18/
      data om14/.0567,.276,.156,1.17,.12,0.785,.058,.048/
      data om15/.113,.138,.313,2.35,.239,.393,.10,.084/
      data om23/.269,1.17,1.36,7.47,.696,7.055,.28,.22/
      data om24/.109,.882,.368,1.79,.201,3.939,.15,.10/
      data om25/.266,.356,.900,3.00,.502,1.533,.19,.13/
      data om34/.097,.493,.336,2.20,.19,2.139,.14,.10/
      data om35/.147,.332,.509,4.99,.279,1.507,.37,.26/
      data om45/.071,.287,.343,2.71,.438,2.065,.15,.12/
c
      data al12/.904,.038,0.,-.161,0.,0.027,2*0./
      data al13/.913,.038,0.,-.160,0.,0.028,2*0./
      data al14/.928,.0738,0.,-.104,0.,0.140,2*0./
      data al15/.921,.0738,0.,-.101,0.,0.140,2*0./
      data al23/1.07,2*0.,-.135,0.,0.086,2*0./
      data al24/.800,.1357,.054,-.153,0.,0.025,2*0./
      data al25/.715,.1357,0.,-.120,0.,0.028,2*0./
      data al34/.691,.1357,0.,-.115,0.,0.027,2*0./
      data al35/.780,.1357,0.,-.141,0.,0.018,2*0./
      data al45/1.110,.049,.109,-.158,0.,0.383,2*0./
      data ama/14.,16.,20.,32.1,22.99,39.948,24.305,28.086/
c hc=h*c=6.626e-27 erg s *2.9979e10 cm/s = 1.9864e-16 erg cm
      data hc/1.9864e-16/
C
      co23t1=0.d0
      co45t1=0.d0
      co45t23=0.d0
      cool=0.0d0
      f23t1=0.0d0
      f45t1=0.0d0
      f45t23=0.0d0
      fp23t1=0.0d0
      fp45t1=0.0d0
      fp45t23=0.0d0
      t23t1=0.0d0
      t45t1=0.0d0
      t45t23=0.0d0
      s23t1=0.0d0
      s45t1=0.0d0
      s45t23=0.0d0
      frr21=0.0d0
      frr41=0.0d0
      IF (abund.ge.1.d-10) THEN
c
      tev=te/1.1609d4
      t4=te/1.d4
      telog=dlog10(te)
      th=telog
      if(th.le.3.d0) th=3.d0
      if(th.ge.4.6d0) th=4.6d0
      time=8.64e4*tday
      deni=den*abund
      dene=den*xe
      cons=8.63d-6*dene/dsqrt(te)
c
      g(1)=4.d0
      g(2)=4.d0
      g(3)=6.d0
      if(i.eq.1.or.i.eq.2) then
       g(2)=6.d0
       g(3)=4.d0
      endif
      if(i.eq.3.or.i.eq.5) then
       g(2)=6.d0
       g(3)=4.d0
      endif
      if(i.ne.2) then
       g(4)=2.d0
       g(5)=4.d0
      else
       g(4)=4.d0
       g(5)=2.d0
      endif
      e21=ene2(i)
c
      ok=.true.
      if (i.eq.2) then
         if ((e21/tev).gt.2.d1) then
            if (fio(id,2).le.0.and.fio(id,3).le.0.) ok=.false.
         endif
      else
         if ((e21/tev).gt.2.d1) ok=.false.
      endif
      if (ok) then
         e31=ene3(i)
         e41=ene4(i)
         e51=ene5(i)
         e32=ene3(i)-ene2(i)
         e42=ene4(i)-ene2(i)
         e52=ene5(i)-ene2(i)
         e43=ene4(i)-ene3(i)
         e53=ene5(i)-ene3(i)
         e54=ene5(i)-ene4(i)
c
         e23t1=(ene2(i)*g(2)+ene3(i)*g(3))/(g(2)+g(3))
         e45t1=(ene4(i)*g(4)+ene5(i)*g(5))/(g(4)+g(5))
         e45t23=(ene4(i)*g(4)+ene5(i)*g(5))/(g(4)+g(5))-
     &        (ene2(i)*g(2)+ene3(i)*g(3))/(g(2)+g(3))
c
         if (initn(i).eq.0) then
            do j1=1,jmax
               if(e21.gt.en(j1).and.e21.le.en(j1+1)) then
                  jln(i,2,1)=j1
                  jln(i,1,2)=j1
                  goto 91
               endif
            enddo
 91         continue
            do j1=1,jmax
               if(e31.gt.en(j1).and.e31.le.en(j1+1)) then
                  jln(i,3,1)=j1
                  jln(i,1,3)=j1
                  goto 92
               endif
            enddo
 92         continue
            do j1=1,jmax
               if(e41.gt.en(j1).and.e41.le.en(j1+1)) then
                  jln(i,4,1)=j1
                  jln(i,1,4)=j1
                  goto 93
               endif
            enddo
 93         continue
            do j1=1,jmax
               if(e51.gt.en(j1).and.e51.le.en(j1+1)) then
                  jln(i,5,1)=j1
                  jln(i,1,5)=j1
                  goto 94
               endif
            enddo
 94         continue
            do j1=1,jmax
               if(e32.gt.en(j1).and.e32.le.en(j1+1)) then
                  jln(i,3,2)=j1
                  jln(i,2,3)=j1
                  goto 95
               endif
            enddo
 95         continue
            do j1=1,jmax
               if(e42.gt.en(j1).and.e42.le.en(j1+1)) then
                  jln(i,4,2)=j1
                  jln(i,2,4)=j1
                  goto 96
               endif
            enddo
 96         continue
            do j1=1,jmax
               if(e52.gt.en(j1).and.e52.le.en(j1+1)) then
                  jln(i,5,2)=j1
                  jln(i,2,5)=j1
                  goto 97
               endif
            enddo
 97         continue
            do j1=1,jmax
               if(e43.gt.en(j1).and.e43.le.en(j1+1)) then
                  jln(i,4,3)=j1
                  jln(i,3,4)=j1
                  goto 98
               endif
            enddo
 98         continue
            do j1=1,jmax
               if(e53.gt.en(j1).and.e53.le.en(j1+1)) then
                  jln(i,5,3)=j1
                  jln(i,3,5)=j1
                  goto 99
               endif
            enddo
 99         continue
            do j1=1,jmax
               if(e54.gt.en(j1).and.e54.le.en(j1+1)) then
                  jln(i,5,4)=j1
                  jln(i,4,5)=j1
                  goto 89
               endif
            enddo
 89         continue
c
            initn(i)=1
         endif
c
         wl21=12398.54d-8/e21
         wl21u3=wl21**3
         wl31=12398.54d-8/e31
         wl31u3=wl31**3
         wl41=12398.54d-8/e41
         wl41u3=wl41**3
         wl51=12398.54d-8/e51
         wl51u3=wl51**3
         wl32=12398.54d-8/e32
         wl32u3=wl32**3
         wl42=12398.54d-8/e42
         wl42u3=wl42**3
         wl52=12398.54d-8/e52
         wl52u3=wl52**3
         wl43=12398.54d-8/e43
         wl43u3=wl43**3
         wl53=12398.54d-8/e53
         wl53u3=wl53**3
         wl54=12398.54d-8/e54
         wl54u3=wl54**3
c
         wl23t1=12398.54d-8/e23t1
         wl23t1u3=wl23t1**3
         wl45t1=12398.54d-8/e45t1
         wl45t1u3=wl45t1**3
         wl45t23=12398.54d-8/e45t23
         wl45t23u3=wl45t23*3
c
         if(i.ne.4) then
            o12=om12(i)*t4**al12(i)
            o13=om13(i)*t4**al13(i)
            o14=om14(i)*t4**al14(i)
            o15=om15(i)*t4**al15(i)
            o23=om23(i)*t4**al23(i)
            o24=om24(i)*t4**al24(i)
            o25=om25(i)*t4**al25(i)
            o34=om34(i)*t4**al34(i)
            o35=om35(i)*t4**al35(i)
            o45=om45(i)*t4**al45(i)
         else
            o12=3.9949-1.1021*th+0.5487*th**2-0.0823*th**3
            o13=6.1758-1.836*th+0.8798*th**2-0.1291*th**3
            o14=13.1138-10.7869*th+2.9634*th**2-0.2608*th**3
            o15=26.7492-22.005*th+6.0445*th**2-0.5322*th**3
            o23=3.2171+3.0844*th-0.3551*th**2-0.038*th**3
            o24=7.0174-5.7352*th+1.8524*th**2-0.187*th**3
            o25=13.3032-10.9238*th+3.4266*th**2-0.3392*th**3
            o34=10.6418-8.6917*th+2.6787*th**2-0.2618*th**3
            o35=23.5642-19.3646*th+6.0722*th**2-0.602*th**3
            o45=37.3916-31.082*th+8.6052*th**2-0.7627*th**3
         endif
         c21=cons*o12/g(2)
         c31=cons*o13/g(3)
         c41=cons*o14/g(4)
         c51=cons*o15/g(5)
         c32=cons*o23/g(3)
         c42=cons*o24/g(4)
         c52=cons*o25/g(5)
         c43=cons*o34/g(4)
         c53=cons*o35/g(5)
         c54=cons*o45/g(5)
         c12=c21*fexp(-e21/tev)*g(2)/g(1)
         c13=c31*fexp(-e31/tev)*g(3)/g(1)
         c14=c41*fexp(-e41/tev)*g(4)/g(1)
         c15=c51*fexp(-e51/tev)*g(5)/g(1)
         c23=c32*fexp(-e32/tev)*g(3)/g(2)
         c24=c42*fexp(-e42/tev)*g(4)/g(2)
         c25=c52*fexp(-e52/tev)*g(5)/g(2)
         c34=c43*fexp(-e43/tev)*g(4)/g(3)
         c35=c53*fexp(-e53/tev)*g(5)/g(3)
         c45=c54*fexp(-e54/tev)*g(5)/g(4)
c
         gie2=0.
         gie3=0.
         gie4=0.
         gie5=0.
         if (i.eq.2) then
c  O II
c  ionization-excitation to O II 2Do
c            gie23=gahe*fieoii2d/(e21*elch)
            gie23=gahe*fio(id,2)/(e21*elch*abund)
c            gie23=gahe*fio(id,2)/(16.9*elch)
            gie2=gie23*g(2)/(g(2)+g(3))
            gie3=gie23*g(3)/(g(2)+g(3))
c  ionization-excitation to O II 2Po
c            gie45=gahe*fieoii2p/(e41*elch)
            gie45=gahe*fio(id,3)/(e41*elch*abund)
c            gie45=gahe*fio(id,3)/(18.6*elch)
            gie4=gie45*g(4)/(g(4)+g(5))
            gie5=gie45*g(5)/(g(4)+g(5))
         endif
cqcq
c         gie2=0.
c         gie3=0.
c         gie4=0.
c         gie5=0.
cqcq
c
c  Photoexcitation/deexcitation (stimulated) by continuum ...
c
      j21=jln(i,2,1)
      j31=jln(i,3,1)
      j41=jln(i,4,1)
      j51=jln(i,5,1)
      j32=jln(i,3,2)
      j42=jln(i,4,2)
      j52=jln(i,5,2)
      j43=jln(i,4,3)
      j53=jln(i,5,3)
      j54=jln(i,5,4)
c  ... and by lines
      k21=kln(i,2,1)
      k31=kln(i,3,1)
      k41=kln(i,4,1)
      k51=kln(i,5,1)
      k32=kln(i,3,2)
      k42=kln(i,4,2)
      k52=kln(i,5,2)
      k43=kln(i,4,3)
      k53=kln(i,5,3)
      k54=kln(i,5,4)
c  change the unit from ../eV to ../Hz
c      flc=fjc(j1)/2.41838e14
c      q1=1./(2.41838e14*1.602e-12)
c      pe21=0.5*(wl21*wl21)*a21(i)*flc/(e21*1.602e-12)
c
      fl21=fjc(j21)/2.41838e14
      fl21=fl21+fjsc(id,iscv(k21))
      pe21=0.5*(wl21*wl21)*a21(i)*fl21/(e21*1.602e-12)
      pe12=(g(2)/g(1))*pe21
      if (pe12.gt.0.) then
         frl=fjsc(id,iscv(k21))/fl21
         frc=1.-frl
         pe12c=pe12*frc
         pe21c=pe21*frc
         pe12l=pe12*frl
         pe21l=pe21*frl
      else
         pe12c=0.d0
         pe21c=0.d0
         pe12l=0.d0
         pe21l=0.d0
      endif
c
      fl31=fjc(j31)/2.41838e14
      fl31=fl31+fjsc(id,iscv(k31))
      pe31=0.5*(wl31*wl31)*a31(i)*fl31/(e31*1.602e-12)
      pe13=(g(3)/g(1))*pe31
      if (pe13.gt.0.) then
         frl=fjsc(id,iscv(k31))/fl31
         frc=1.-frl
         pe13c=pe13*frc
         pe31c=pe31*frc
         pe13l=pe13*frl
         pe31l=pe31*frl
      else
         pe13c=0.d0
         pe31c=0.d0
         pe13l=0.d0
         pe31l=0.d0
      endif
c
      fl41=fjc(j41)/2.41838e14
      fl41=fl41+fjsc(id,iscv(k41))
      pe41=0.5*(wl41*wl41)*a41(i)*fl41/(e41*1.602e-12)
      pe14=(g(4)/g(1))*pe41
      if (pe14.gt.0.) then
         frl=fjsc(id,iscv(k41))/fl41
         frc=1.-frl
         pe14c=pe14*frc
         pe41c=pe41*frc
         pe14l=pe14*frl
         pe41l=pe41*frl
      else
         pe14c=0.d0
         pe41c=0.d0
         pe14l=0.d0
         pe41l=0.d0
      endif
c
      fl51=fjc(j51)/2.41838e14
      fl51=fl51+fjsc(id,iscv(k51))
      pe51=0.5*(wl51*wl51)*a51(i)*fl51/(e51*1.602e-12)
      pe15=(g(5)/g(1))*pe51
      if (pe15.gt.0.) then
         frl=fjsc(id,iscv(k51))/fl51
         frc=1.-frl
         pe15c=pe15*frc
         pe51c=pe51*frc
         pe15l=pe15*frl
         pe51l=pe51*frl
      else
         pe15c=0.d0
         pe51c=0.d0
         pe15l=0.d0
         pe51l=0.d0
      endif
c
      fl32=fjc(j32)/2.41838e14
      fl32=fl32+fjsc(id,iscv(k32))
      pe32=0.5*(wl32*wl32)*a32(i)*fl32/(e32*1.602e-12)
      pe23=(g(3)/g(2))*pe32
      if (pe23.gt.0.) then
         frl=fjsc(id,iscv(k32))/fl32
         frc=1.-frl
         pe23c=pe23*frc
         pe32c=pe32*frc
         pe23l=pe23*frl
         pe32l=pe32*frl
      else
         pe23c=0.d0
         pe32c=0.d0
         pe23l=0.d0
         pe32l=0.d0
      endif
c
      fl42=fjc(j42)/2.41838e14
      fl42=fl42+fjsc(id,iscv(k42))
      pe42=0.5*(wl42*wl42)*a42(i)*fl42/(e42*1.602e-12)
      pe24=(g(4)/g(2))*pe42
      if (pe24.gt.0.) then
         frl=fjsc(id,iscv(k42))/fl42
         frc=1.-frl
         pe24c=pe24*frc
         pe42c=pe42*frc
         pe24l=pe24*frl
         pe42l=pe42*frl
      else
         pe24c=0.d0
         pe42c=0.d0
         pe24l=0.d0
         pe42l=0.d0
      endif
c
      fl52=fjc(j52)/2.41838e14
      fl52=fl52+fjsc(id,iscv(k52))
      pe52=0.5*(wl52*wl52)*a52(i)*fl52/(e52*1.602e-12)
      pe25=(g(5)/g(2))*pe52
      if (pe25.gt.0.) then
         frl=fjsc(id,iscv(k52))/fl52
         frc=1.-frl
         pe25c=pe25*frc
         pe52c=pe52*frc
         pe25l=pe25*frl
         pe52l=pe52*frl
      else
         pe25c=0.d0
         pe52c=0.d0
         pe25l=0.d0
         pe52l=0.d0
      endif
c
      fl43=fjc(j43)/2.41838e14
      fl43=fl43+fjsc(id,iscv(k43))
      pe43=0.5*(wl43*wl43)*a43(i)*fl43/(e43*1.602e-12)
      pe34=(g(4)/g(3))*pe43
      if (pe34.gt.0.) then
         frl=fjsc(id,iscv(k43))/fl43
         frc=1.-frl
         pe34c=pe34*frc
         pe43c=pe43*frc
         pe34l=pe34*frl
         pe43l=pe43*frl
      else
         pe34c=0.d0
         pe43c=0.d0
         pe34l=0.d0
         pe43l=0.d0
      endif
c
      fl53=fjc(j53)/2.41838e14
      fl53=fl53+fjsc(id,iscv(k53))
      pe53=0.5*(wl53*wl53)*a53(i)*fl53/(e53*1.602e-12)
      pe35=(g(5)/g(3))*pe53
      if (pe35.gt.0.) then
         frl=fjsc(id,iscv(k53))/fl53
         frc=1.-frl
         pe35c=pe35*frc
         pe53c=pe53*frc
         pe35l=pe35*frl
         pe53l=pe53*frl
      else
         pe35c=0.d0
         pe53c=0.d0
         pe35l=0.d0
         pe53l=0.d0
      endif
c
      fl54=fjc(j54)/2.41838e14
      fl54=fl54+fjsc(id,iscv(k54))
      pe54=0.5*(wl54*wl54)*a54(i)*fl54/(e54*1.602e-12)
      pe45=(g(5)/g(4))*pe54
      if (pe45.gt.0.) then
         frl=fjsc(id,iscv(k54))/fl54
         frc=1.-frl
         pe45c=pe45*frc
         pe54c=pe54*frc
         pe45l=pe45*frl
         pe54l=pe54*frl
      else
         pe45c=0.d0
         pe54c=0.d0
         pe45l=0.d0
         pe54l=0.d0
      endif
c
c  start-values
      x(1)=1.0
      do j=2,5
         x(j)=1.d-10
      enddo
c
         do it=1,itmax
c
c calculate the escape probability : p21,p31,p41,p51,p32,p42,p52,p43,p53,p54
c p21
            t0=wl21u3*a21(i)*g(2)*deni*x(1)*(1.-g(1)*x(2)
     &		/(g(2)*x(1)))*time/(8.*pi*g(1))
            if (t0.lt.0.01) then
               p21=1.-0.5*t0+(t0**2)/6.
            elseif(t0.ge.0.01) then
               p21=(1.-fexp(-t0))/t0
            endif
c p31
            t0=wl31u3*a31(i)*g(3)*deni*x(1)*(1.-g(1)*x(3)
     &		/(g(3)*x(1)))*time/(8.*pi*g(1))
            if (t0.lt.0.01) then
               p31=1.-0.5*t0+(t0**2)/6.
            elseif(t0.ge.0.01) then
               p31=(1.-fexp(-t0))/t0
            endif
c p41
            t0=wl41u3*a41(i)*g(4)*deni*x(1)*(1.-g(1)*x(4)
     &		/(g(4)*x(1)))*time/(8.*pi*g(1))
            if (t0.lt.0.01) then
               p41=1.-0.5*t0+(t0**2)/6.
            elseif(t0.ge.0.01) then
               p41=(1.-fexp(-t0))/t0
            endif
c p51
            t0=wl51u3*a51(i)*g(5)*deni*x(1)*(1.-g(1)*x(5)
     &		/(g(5)*x(1)))*time/(8.*pi*g(1))
            if (t0.lt.0.01) then
               p51=1.-0.5*t0+(t0**2)/6.
            elseif(t0.ge.0.01) then
               p51=(1.-fexp(-t0))/t0
            endif
c p32
            t0=wl32u3*a32(i)*g(3)*deni*x(2)*(1.-g(2)*x(3)
     &		/(g(3)*x(2)))*time/(8.*pi*g(2))
            if (t0.lt.0.01) then
               p32=1.-0.5*t0+(t0**2)/6.
            elseif(t0.ge.0.01) then
               p32=(1.-fexp(-t0))/t0
            endif
c p42
            t0=wl42u3*a42(i)*g(4)*deni*x(2)*(1.-g(2)*x(4)
     &		/(g(4)*x(2)))*time/(8.*pi*g(2))
            if (t0.lt.0.01) then
               p42=1.-0.5*t0+(t0**2)/6.
            elseif(t0.ge.0.01) then
               p42=(1.-fexp(-t0))/t0
            endif
c p52
            t0=wl52u3*a52(i)*g(5)*deni*x(2)*(1.-g(2)*x(5)
     &		/(g(5)*x(2)))*time/(8.*pi*g(2))
            if (t0.lt.0.01) then
               p52=1.-0.5*t0+(t0**2)/6.
            elseif(t0.ge.0.01) then
               p52=(1.-fexp(-t0))/t0
            endif
c p43
            t0=wl43u3*a43(i)*g(4)*deni*x(3)*(1.-g(3)*x(4)
     &		/(g(4)*x(3)))*time/(8.*pi*g(3))
            if (t0.lt.0.01) then
               p43=1.-0.5*t0+(t0**2)/6.
            elseif(t0.ge.0.01) then
               p43=(1.-fexp(-t0))/t0
            endif
c p53
            t0=wl53u3*a53(i)*g(5)*deni*x(3)*(1.-g(3)*x(5)
     &		/(g(5)*x(3)))*time/(8.*pi*g(3))
            if (t0.lt.0.01) then
               p53=1.-0.5*t0+(t0**2)/6.
            elseif(t0.ge.0.01) then
               p53=(1.-fexp(-t0))/t0
            endif
c p54
            t0=wl54u3*a54(i)*g(5)*deni*x(4)*(1.-g(4)*x(5)
     &		/(g(5)*x(4)))*time/(8.*pi*g(4))
            if (t0.lt.0.01) then
               p54=1.-0.5*t0+(t0**2)/6.
            elseif(t0.ge.0.01) then
               p54=(1.-fexp(-t0))/t0
            endif
c
ck            a(1,1)=c12+c13+c14+c15
ck            a(1,2)=-(c21+p21*a21(i))
ck            a(1,3)=-(c31+p31*a31(i))
ck            a(1,4)=-(c41+p41*a41(i))
ck            a(1,5)=-(c51+p51*a51(i))
ck            b(1)=0.d0
            do j=1,5
               a(1,j)=1.d0
            enddo
            b(1)=1.d0
ck
            a(2,1)=-c12-pe12*p21
            a(2,2)=c21+c23+c24+c25+p21*(a21(i)+pe21)
            a(2,2)=a(2,2)+pe23*p32+pe24*p42+pe25*p52
            a(2,3)=-(c32+p32*(a32(i)+pe32))
            a(2,4)=-(c42+p42*(a42(i)+pe42))
            a(2,5)=-(c52+p52*(a52(i)+pe52))
            b(2)=gie2
ck            do j=1,5
ck               a(3,j)=1.d0
ck            enddo
ck            b(3)=1.d0
            a(3,1)=-c13-pe13*p31
            a(3,2)=-c23-pe23*p32
            a(3,3)=c31+c32+c34+c35+p31*(a31(i)+pe31)+
     &           p32*(a32(i)+pe32)
            a(3,3)=a(3,3)+pe34*p43+pe35*p53
            a(3,4)=-(c43+p43*(a43(i)+pe43))
            a(3,5)=-(c53+p53*(a53(i)+pe53))
            b(3)=gie3
ck
            a(4,1)=-c14-pe14*p41
            a(4,2)=-c24-pe24*p42
            a(4,3)=-c34-pe34*p43
            a(4,4)=c41+c42+c43+c45+p41*(a41(i)+pe41)+p42*(a42(i)+pe42)+
     &           p43*(a43(i)+pe43)+pe45*p54
            a(4,5)=-(c54+p54*(a54(i)+pe54))
            b(4)=gie4
c
            a(5,1)=-c15-pe15*p51
            a(5,2)=-c25-pe25*p52
            a(5,3)=-c35-pe35*p53
            a(5,4)=-c45-pe45*p54
            a(5,5)=c51+c52+c53+c54+p51*(a51(i)+pe51)+p52*(a52(i)+pe52)+
     &           p53*(a53(i)+pe53)+p54*(a54(i)+pe54)
            b(5)=gie5
c
            call matrixb(5,8)
c
            dxmax=0.
            do j=1,5
               dx=abs((b(j)-x(j))/b(j))
               if (dx.gt.dxmax) dxmax=dx
               x(j)=b(j)
            enddo
c
            if(dxmax.lt.tol) goto 9988
         enddo
         if (it.ge.itmax) write(50,701) 'nforb : no conv!',i,
     &        tday,abund,id
9988     continue
 701     format(a,i5,f10.2,1pe12.4,i5)
c
         elab=(1.6022d-12*abund)/dene
         co23t1=elab*(e21*(x(1)*c12-x(2)*c21)+
     &        e31*(x(1)*c13-x(3)*c31))
         co45t1=elab*(e41*(x(1)*c14-x(4)*c41)+
     &        e51*(x(1)*c15-x(5)*c51))
         co45t23=elab*(e42*(x(2)*c24-x(4)*c42)+
     &        e52*(x(2)*c25-x(5)*c52)+e43*(x(3)*c34-x(4)*c43)+
     &        e53*(x(3)*c35-x(5)*c53))
c
         coolx=elab*(e32*(x(2)*c23-x(3)*c32)+
     &        e54*(x(4)*c45-x(5)*c54))
         cool=co23t1+co45t1+co45t23+coolx
c
         f23t1=elab*(x(2)*p21*a21(i)*e21+x(3)*p31*a31(i)*e31)
         fp23t1=elab*(p21*e21*x(2)*pe21+
     &        p31*e31*x(3)*pe31)
         phextot=phextot+elab*
     &        (p21*e21*(x(1)*pe12-x(2)*pe21)+
     &        p31*e31*(x(1)*pe13-x(3)*pe31))
         phextc=phextc+elab*
     &        (p21*e21*(x(1)*pe12c-x(2)*pe21c)+
     &        p31*e31*(x(1)*pe13c-x(3)*pe31c))
c     &        (p21*e21*x(1)*pe12c+
c     &        p31*e31*x(1)*pe13c)
         dphextl=elab*
     &        (p21*e21*(x(1)*pe12l-x(2)*pe21l)+
     &        p31*e31*(x(1)*pe13l-x(3)*pe31l))
c     &        (p21*e21*x(1)*pe12l+
c     &        p31*e31*x(1)*pe13l)
         phextl=phextl+dphextl
cqcq run 99 
         phexlm(id,k21)=dphextl
c
c not correct
c         t23t1=0.
cnew9802
         g23=g(2)+g(3)
         x23=x(2)+x(3)
         a23t1=(a21(i)*x(2)+a31(i)*x(3))/x23
         t23t1=wl23t1u3*a23t1*g23*deni*x(1)*(1.-g(1)*x23
     &        /(g23*x(1)))*time/(8.*pi*g(1))
         if (x23.gt.1.e-40) then         
            s23t1=(2.*hc/wl23t1u3)/((x(1)*g23)/(x23*g(1))-1)
         else
            s23t1=0.d0
         endif
c
c         fp23t1=elab*(p21*e21*(x(2)*pe21-x(1)*pe12)+
c     &        p31*e31*(x(3)*pe31-x(1)*pe13))
         f45t1=elab*(x(4)*p41*a41(i)*e41+x(5)*p51*a51(i)*e51)
         fp45t1=elab*(p41*e41*x(4)*pe41+
     &        p51*e51*x(5)*pe51)
         phextot=phextot+elab*
     &        (p41*e41*(x(1)*pe14-x(4)*pe41)+
     &        p51*e51*(x(1)*pe15-x(5)*pe51))
         phextc=phextc+elab*
     &        (p41*e41*(x(1)*pe14c-x(4)*pe41c)+
     &        p51*e51*(x(1)*pe15c-x(5)*pe51c))
c     &        (p41*e41*x(1)*pe14c+
c     &        p51*e51*x(1)*pe15c)
         dphextl=elab*
     &        (p41*e41*(x(1)*pe14l-x(4)*pe41l)+
     &        p51*e51*(x(1)*pe15l-x(5)*pe51l))
c     &        (p41*e41*x(1)*pe14l+
c     &        p51*e51*x(1)*pe15l)
         phextl=phextl+dphextl
cqcq run 99 
         phexlm(id,k41)=dphextl
c
c not correct
c         t45t1=0.
cnew9802
         g45=g(4)+g(5)
         x45=x(4)+x(5)
         a45t1=(x(4)*a41(i)+x(5)*a51(i))/x45
         t45t1=wl45t1u3*a45t1*g45*deni*x(1)*(1.-g(1)*x45
     &        /(g45*x(1)))*time/(8.*pi*g(1))
         if (x45.gt.1.e-40) then         
            s45t1=(2.*hc/wl45t1u3)/((x(1)*g45)/(x45*g(1))-1)
         else
            s45t1=0.d0
         endif
c
c         fp45t1=elab*(p41*e41*(x(4)*pe41-x(1)*pe14)+
c     &        p51*e51*(x(5)*pe51-x(1)*pe15))
         f45t23=elab*(x(4)*(e42*a42(i)*p42+e43*a43(i)*p43)+x(5)*
     &        (e52*a52(i)*p52+e53*a53(i)*p53))
         fp45t23=elab*(e42*p42*x(4)*pe42+
     &        e43*p43*x(4)*pe43+
     &        e52*p52*x(5)*pe52+
     &        e53*p53*x(5)*pe53)
         phextot=phextot+elab*
     &        (e42*p42*(x(2)*pe24-x(4)*pe42)+
     &        e43*p43*(x(3)*pe34-x(4)*pe43)+
     &        e52*p52*(x(2)*pe25-x(5)*pe52)+
     &        e53*p53*(x(3)*pe35-x(5)*pe53))
         phextc=phextc+elab*
     &        (e42*p42*(x(2)*pe24c-x(4)*pe42c)+
     &        e43*p43*(x(3)*pe34c-x(4)*pe43c)+
     &        e52*p52*(x(2)*pe25c-x(5)*pe52c)+
     &        e53*p53*(x(3)*pe35c-x(5)*pe53c))
c     &        (e42*p42*x(2)*pe24c+
c     &        e43*p43*x(3)*pe34c+
c     &        e52*p52*x(2)*pe25c+
c     &        e53*p53*x(3)*pe35c)
         dphextl=elab*
     &        (e42*p42*(x(2)*pe24l-x(4)*pe42l)+
     &        e43*p43*(x(3)*pe34l-x(4)*pe43l)+
     &        e52*p52*(x(2)*pe25l-x(5)*pe52l)+
     &        e53*p53*(x(3)*pe35l-x(5)*pe53l))
c     &        (e42*p42*x(2)*pe24l+
c     &        e43*p43*x(3)*pe34l+
c     &        e52*p52*x(2)*pe25l+
c     &        e53*p53*x(3)*pe35l)
         phextl=phextl+dphextl
cqcq run 99 
         phexlm(id,k42)=dphextl
c
c not correct
c         t45t23=0.
cnew9802
         g23=g(2)+g(3)
         g45=g(4)+g(5)
         x23=x(2)+x(3)
         x45=x(4)+x(5)
         a45t23=(x(4)*(a42(i)+a43(i))+
     &        x(5)*(a52(i)+a53(i)))/x45
         t45t23=wl45t23u3*a45t23*g45*deni*x23*(1.-g23*x45
     &        /(g45*x23))*time/(8.*pi*g23)
         if (x45.gt.1.e-40) then         
            s45t23=(2.*hc/wl45t23u3)/((x23*g45)/(x45*g23)-1)
         else
            s45t23=0.d0
         endif
c
c         fp45t23=elab*(e42*p42*(x(4)*pe42-x(2)*pe24)+
c     &        e43*p43*(x(4)*pe43-x(3)*pe34)+
c     &        e52*p52*(x(5)*pe52-x(2)*pe25)+
c     &        e53*p53*(x(5)*pe53-x(3)*pe35))
C - line ratios -
         frr21=(elab*e21*p21*(x(2)*a21(i)+x(2)*pe21-x(1)*pe12))/
     &        (f23t1+fp23t1)
         if(i.ne.2) then
            frr41=(elab*e41*p41*x(4)*(a41(i)+pe41))/
     &           (f45t1+fp45t1)
         else
            frr41=(elab/(f45t23+fp45t23))*
     &           (p43*e43*x(4)*(a43(i)+pe43)+
     &            p53*e53*x(5)*(a53(i)+pe53))
         endif
c
         phed(j21)=phed(j21)+elab*p21*e21*(x(1)*pe12-x(2)*pe21)
         phed(j31)=phed(j31)+elab*p31*e31*(x(1)*pe13-x(3)*pe31)
         phed(j41)=phed(j41)+elab*p41*e41*(x(1)*pe14-x(4)*pe41)
         phed(j51)=phed(j51)+elab*p51*e51*(x(1)*pe15-x(5)*pe51)
c         phed(j32)=phed(j32)+elab*p32*e32*x(2)*pe23
         phed(j42)=phed(j42)+elab*p42*e42*(x(2)*pe24-x(4)*pe42)
         phed(j52)=phed(j52)+elab*p52*e52*(x(2)*pe25-x(5)*pe52)
         phed(j43)=phed(j43)+elab*p43*e43*(x(3)*pe34-x(4)*pe43)
         phed(j53)=phed(j53)+elab*p53*e53*(x(3)*pe35-x(5)*pe53)
c         phed(j54)=phed(j54)+
      endif
      ENDIF
C
      return
      end

C*********************************************************************
C*********************************************************************
      subroutine oforb(te,xe,i,abund,f21,f32,f4t123,f5t12,f54,
     &fp21,fp32,fp4t123,fp5t12,fpt54,t21,t32,t4t123,t5t12,t54,
     &s21,s32,s4t123,s5t12,s54,wl4t123,wl5t12,
     &co21,co32,co4t123,co5t12,co54,cool)
C*********************************************************************
C  Forbidden lines (O I-like). Enumeration of the ions are: (= I)
c
C  1 = O I  2 = Ne III  3 = S I  4 = Na IV  5 = Mg V  6 = Ar III  
C  7 = Ca V
c
C  The atom is treated as a 5-level atom. (The energy levels of lower
C  3P-state are inverted compared to C I-like states.)
C  (The atom is reduced to a 3-level atom for E43/Tev > 20)
c
C  ene4 & ene5 of Ar III from Hansen & Persson ('87). Other energies 
C  from Mendoza ('83). A-values and Omegas from Mendoza ('83) and
C  Osterbrock ('89), except Omegas of Ar III and Ca V which are from
C  Galavis et al. (AAS, 111, 347, '95), and of O I (Berrington, 
C  J.Phys.B 21, 1083, '87). S I Omegas are assumed to follow those of 
C  O I, which is probably an underestimate. 
c
c New 990830: 
c  -   Neon (Ne III) from Pradhan & Peng:
c      Atomic Data For The Analysis of Emission Lines 
c      By Anil K. Pradhan and Jianfang Peng 
c     "The Analysis of Emission Lines", Space Telescope Science 
c      Institute Symposium Series No. 8, Ed: R.E.Williams and 
c      M.Livio, Cambridge University Press (1995). 
c
c  -   Include the following ions : Na IV,Mg V,Ar III,Ca V
c
c  -   Ar III : A-values and omegas from Pradhan & Peng 1995
C*********************************************************************
      implicit real*8(a-h,o-z)
C
      include 'INCLUDE/PARAM.IOR'
      parameter(itmax=50)
c
      common/coforb/inito(7),jlo(7,5,5),klo(7,5,5)
      common/cden/den
      common/ctpar/tday,dts,iss,iss1,itd
      common/depthind/id
      common/cmat/a(mmax,mmax),b(mmax)
      common/cebin/e1(ne),en(ne),jmax
      common/cfj/fj(ne),fjidm1(ne),fjc(0:ne),fjcidm1(ne)
      common/cphed/phed(0:ne),phextot,phextc,phextl,phexlm(mid,lmax),
     &     eq1(1200),klq1(1200),kl1m
      common/cscat/fjsc(mid,0:lmax),kksc(lmax),iscv(0:lmax),
     &           is1(lmax),is0(lmax),is2(lmax),iscm,klsc,iflscat
      data pi/3.1415926e0/,tol/0.00001/
c
      dimension ene2(7),ene3(7),ene4(7),ene5(7),a21(7),a31(7),
     &a41(7),a51(7),a32(7),a42(7),a52(7),a43(7),a54(7),
     &om12(7),om13(7),om23(7),om123t4(7),om12t5(7),om45(7),
     &al12(7),al13(7),al23(7),al123t4(7),al12t5(7),al45(7),g(5),
     &ama(7),x(5)
c
      data ene2/.01965,.07966,.04908,.13707,.22093,.13779,.29794/
      data ene3/.02809,.1141,.07108,.19522,.31245,.19455,.40585/
      data ene4/1.9660,3.2017,1.1447,3.8211,4.4520,1.6685,2.3331/
      data ene5/4.1869,6.9075,2.7481,8.2389,9.5757,4.0455,5.4313/
c new data 960325
cold a41(3)=2.78d-3 
cnew a41(3)=2.78d-2
      data a21/8.92d-5,5.97d-3,1.39d-3,3.04d-2,.127d0,3.08d-2,
     &.31d0/
      data a31/0.,2.18d-8,6.71d-8,1.67d-7,1.01d-6,2.37d-6,3.67d-5/
      data a41/6.34d-3,.171d0,2.78d-2,.61d0,1.85d0,0.314d0,1.9d0/
      data a51/2.88d-4,3.94d-3,8.23d-3,1.05d-2,2.45d-2,4.17d-2,
     &.145d0/
      data a32/1.74d-5,1.15d-3,3.02d-4,5.57d-3,2.17d-2,5.17d-3,
     &3.54d-2/
      data a42/2.11d-3,5.42d-2,8.16d-3,.186d0,.541d0,8.23d-2,
     &.426d0/
      data a52/7.32d-2,2.00,.35d0,7.1d0,21.4d0,3.91d0,23.1d0/
      data a43/7.23d-7,8.51d-6,3.84d-6,2.24d-5,5.2d-5,2.21d-5,
     &8.42d-5/
      data a54/1.22d0,2.71d0,1.53d0,3.46d0,4.23d0,2.59d0,3.73d0/
c new data 990830 for neon from pradhan & peng
cold      data om12/0.,.527,0./,om13/0.,.131,0./,om23/0.,.185,0./
cold      data om123t4/0.,1.34,0./,om12t5/0.,.151,0./,om45/0.,.236,0./
cold      data al12/3*0./,al13/3*0./,al23/3*0./,al123t4/3*0./
cold      data al12t5/3*0./,al45/0.,.184,0./
c new data 990830 for Ar III from pradhan & peng
cold      data om12/0.,1.65,0.,.471,.4,3.1,2.3/
cold      data om13/0.,.300,0.,.111,.091,.671,.648/
cold      data om23/0.,.330,0.,.177,.156,1.261,.671/
cold      data om123t4/0.,1.63,0.,1.17,1.02,4.825,3.067/
cold      data om12t5/0.,.169,0.,.163,.146,.841,.522/
cold      data om45/0.,.226,0.,.157,.129,1.219,1.348/
cold      data al12/5*0.,.034,.163/
cold      data al13/5*0.,.16,.176/
cold      data al23/5*0.,-.098,.141/
cold      data al123t4/5*0.,-.065,.104/
cold      data al12t5/0.,0.088,3*0.,-.099,.185/
cold      data al45/0.,.176,3*0.,-.152,0./
c
      data om12/0.,1.65,0.,.471,.4,2.24,2.3/
      data om13/0.,.300,0.,.111,.091,0.531,.648/
      data om23/0.,.330,0.,.177,.156,1.18,.671/
      data om123t4/0.,1.63,0.,1.17,1.02,4.74,3.067/
      data om12t5/0.,.169,0.,.163,.146,.680,.522/
      data om45/0.,.226,0.,.157,.129,0.823,1.348/
      data al12/6*0.,.163/
      data al13/6*0.,.176/
      data al23/6*0.,.141/
      data al123t4/6*0.,.104/
      data al12t5/0.,0.088,4*0.,.185/
      data al45/0.,.176,5*0./
c
      data g/5.,3.,1.,5.,1./
      data ama/16.,20.,32.1,22.99,24.305,39.948,40.08/
c hc=h*c=6.626e-27 erg s *2.9979e10 cm/s = 1.9864e-16 erg cm
      data hc/1.9864e-16/
C
      co21=0.d0
      co32=0.d0
      co4t123=0.d0
      co5t12=0.d0
      co54=0.d0
      cool=0.0d0
      f21=0.0d0
      f32=0.0d0
      f4t123=0.0d0
      f5t12=0.0d0
      f54=0.0d0
      fp21=0.0d0
      fp32=0.0d0
      fp4t123=0.0d0
      fp5t12=0.0d0
      fp54=0.0d0
      t21=0.0d0
      t32=0.0d0
      t4t123=0.0d0
      t5t12=0.0d0
      t54=0.0d0
      s21=0.0d0
      s32=0.0d0
      s4t123=0.0d0
      s5t12=0.0d0
      s54=0.0d0
      IF (abund.ge.1.d-10) THEN
c
      tev=te/1.1609d4
      t4=te/1.d4
      telog=dlog10(te)
      th=dmax1(telog,3.4d0)
      th=dmin1(5.d0,th)
      time=8.64e4*tday
      deni=den*abund
      dene=den*xe
      cons=8.63d-6*dene/dsqrt(te)
c
      e21=ene2(i)
      e31=ene3(i)
      e41=ene4(i)
      e51=ene5(i)
      e32=ene3(i)-ene2(i)
      e42=ene4(i)-ene2(i)
      e52=ene5(i)-ene2(i)
      e43=ene4(i)-ene3(i)
      e53=ene5(i)-ene3(i)
      e54=ene5(i)-ene4(i)
c
      e5t12=ene5(i)-(g(2)*ene2(i))/(g(1)+g(2))
      e4t123=ene4(i)-
     &     (g(2)*ene2(i)+g(3)*ene3(i))/(g(1)+g(2)+g(3))
c
      if (inito(i).eq.0) then
         do j1=1,jmax
            if(e21.gt.en(j1).and.e21.le.en(j1+1)) then
               jlo(i,2,1)=j1
               jlo(i,1,2)=j1
               goto 91
            endif
         enddo
 91      continue
         do j1=1,jmax
            if(e31.gt.en(j1).and.e31.le.en(j1+1)) then
               jlo(i,3,1)=j1
               jlo(i,1,3)=j1
               goto 92
            endif
         enddo
 92      continue
         do j1=1,jmax
            if(e41.gt.en(j1).and.e41.le.en(j1+1)) then
               jlo(i,4,1)=j1
               jlo(i,1,4)=j1
               goto 93
            endif
         enddo
 93      continue
         do j1=1,jmax
            if(e51.gt.en(j1).and.e51.le.en(j1+1)) then
               jlo(i,5,1)=j1
               jlo(i,1,5)=j1
               goto 94
            endif
         enddo
 94      continue
         do j1=1,jmax
            if(e32.gt.en(j1).and.e32.le.en(j1+1)) then
               jlo(i,3,2)=j1
               jlo(i,2,3)=j1
               goto 95
            endif
         enddo
 95      continue
         do j1=1,jmax
            if(e42.gt.en(j1).and.e42.le.en(j1+1)) then
               jlo(i,4,2)=j1
               jlo(i,2,4)=j1
               goto 96
            endif
         enddo
 96      continue
         do j1=1,jmax
            if(e52.gt.en(j1).and.e52.le.en(j1+1)) then
               jlo(i,5,2)=j1
               jlo(i,2,5)=j1
               goto 97
            endif
         enddo
 97      continue
         do j1=1,jmax
            if(e43.gt.en(j1).and.e43.le.en(j1+1)) then
               jlo(i,4,3)=j1
               jlo(i,3,4)=j1
               goto 98
            endif
         enddo
 98      continue
         do j1=1,jmax
            if(e53.gt.en(j1).and.e53.le.en(j1+1)) then
               jlo(i,5,3)=j1
               jlo(i,3,5)=j1
               goto 99
            endif
         enddo
 99      continue
         do j1=1,jmax
            if(e54.gt.en(j1).and.e54.le.en(j1+1)) then
               jlo(i,5,4)=j1
               jlo(i,4,5)=j1
               goto 89
            endif
         enddo
 89      continue
c
         inito(i)=1
      endif
c
      wl21=12398.54d-8/e21
      wl21u3=wl21**3
      wl31=12398.54d-8/e31
      wl31u3=wl31**3
      wl41=12398.54d-8/e41
      wl41u3=wl41**3
      wl51=12398.54d-8/e51
      wl51u3=wl51**3
      wl32=12398.54d-8/e32
      wl32u3=wl32**3
      wl42=12398.54d-8/e42
      wl42u3=wl42**3
      wl52=12398.54d-8/e52
      wl52u3=wl52**3
      wl43=12398.54d-8/e43
      wl43u3=wl43**3
      wl53=12398.54d-8/e53
      wl53u3=wl53**3
      wl54=12398.54d-8/e54
      wl54u3=wl54**3
c
      wl5t12=12398.54d-8/e5t12
      wl5t12u3=wl5t12**3
      wl4t123=12398.54d-8/e4t123
      wl4t123u3=wl4t123**3
c
      gsum=g(1)+g(2)+g(3)
C -- S I omegas assumed to follow those of O I (probably an
C    underestimate !) --
c -- O I from Berrington, J.Phys.B 21, 1083 (1987) --
      if(i.eq.1.or.i.eq.3) then
         o45=1.05d-1*t4**0.520d0
         if(te.le.1.d3) then
            o12=9.72d-3*(te/1.d3)**.773d0
            o13=4.11d-3*(te/1.d3)**.676d0
            o23=6.36d-4*(te/1.d3)**1.301d0
            o123t4=1.51d-2*(te/1.d3)**1.380d0
            o12t5=1.84d-3*(te/1.d3)**1.501d0
         else 
            o12=9.72d-3*(te/1.d3)**1.038d0
            o13=4.11d-3*(te/1.d3)**.893d0
            o23=6.36d-4*(te/1.d3)**1.648d0
            o123t4=2.66d-1*t4**1.246d0
            o12t5=3.24d-2*t4**1.246d0
         endif
c -- Neon (from Mendoza) --
c New 990830 neon from Pradhan & Peng
      elseif (i.eq.2) then
         o12=om12(i)*t4**al12(i)
         if (t4.le.0.5) o12=1.09
         o13=om13(i)*t4**al13(i)
         o23=om23(i)*t4**al23(i)
         o123t4=om123t4(i)*t4**al123t4(i)
         o12t5=om12t5(i)*t4**al12t5(i)
         o45=om45(i)*t4**al45(i)
      else
         o12=om12(i)*t4**al12(i)
         o13=om13(i)*t4**al13(i)
         o23=om23(i)*t4**al23(i)
         o123t4=om123t4(i)*t4**al123t4(i)
         o12t5=om12t5(i)*t4**al12t5(i)
         o45=om45(i)*t4**al45(i)
      endif
      c21=cons*o12/g(2)
      c31=cons*o13/g(3)
      c32=cons*o23/g(3)
      c12=c21*fexp(-e21/tev)*g(2)/g(1)
      c13=c31*fexp(-e31/tev)*g(3)/g(1)
      c23=c32*fexp(-e32/tev)*g(3)/g(2)
      if ((e43/tev).lt.2.d1) then
        o14=g(1)*o123t4/gsum
        o24=g(2)*o14/g(1)
        o34=g(3)*o14/g(1)
        o25=g(2)*o12t5/(g(1)+g(2))
        o15=g(1)*o25/g(2)
        o35=g(3)*o25/g(2)
        c41=cons*o14/g(4)
        c51=cons*o15/g(5)
        c42=cons*o24/g(4)
        c52=cons*o25/g(5)
        c43=cons*o34/g(4)
        c53=cons*o35/g(5)
        c54=cons*o45/g(5)
        c14=c41*fexp(-e41/tev)*g(4)/g(1)
        c15=c51*fexp(-e51/tev)*g(5)/g(1)
        c24=c42*fexp(-e42/tev)*g(4)/g(2)
        c25=c52*fexp(-e52/tev)*g(5)/g(2)
        c34=c43*fexp(-e43/tev)*g(4)/g(3)
        c35=c53*fexp(-e53/tev)*g(5)/g(3)
        c45=c54*fexp(-e54/tev)*g(5)/g(4)
      endif
c
c  Photoexcitation/deexcitation (stimulated) by continuum ...
c
      j21=jlo(i,2,1)
      j31=jlo(i,3,1)
      j41=jlo(i,4,1)
      j51=jlo(i,5,1)
      j32=jlo(i,3,2)
      j42=jlo(i,4,2)
      j52=jlo(i,5,2)
      j43=jlo(i,4,3)
      j53=jlo(i,5,3)
      j54=jlo(i,5,4)
c  ... and by lines
      k21=klo(i,2,1)
      k31=klo(i,3,1)
      k41=klo(i,4,1)
      k51=klo(i,5,1)
      k32=klo(i,3,2)
      k42=klo(i,4,2)
      k52=klo(i,5,2)
      k43=klo(i,4,3)
      k53=klo(i,5,3)
      k54=klo(i,5,4)
c  change the unit from ../eV to ../Hz
c      flc=fjc(j1)/2.41838e14
c      q1=1./(2.41838e14*1.602e-12)
c      pe21=0.5*(wl21*wl21)*a21(i)*flc/(e21*1.602e-12)
c
      fl21=fjc(j21)/2.41838e14
      fl21=fl21+fjsc(id,iscv(k21))
      pe21=0.5*(wl21*wl21)*a21(i)*fl21/(e21*1.602e-12)
      pe12=(g(2)/g(1))*pe21
      if (pe12.gt.0.) then
         frl=fjsc(id,iscv(k21))/fl21
         frc=1.-frl
         pe12c=pe12*frc
         pe21c=pe21*frc
         pe12l=pe12*frl
         pe21l=pe21*frl
      else
         pe12c=0.d0
         pe21c=0.d0
         pe12l=0.d0
         pe21l=0.d0
      endif
c
      fl31=fjc(j31)/2.41838e14
      fl31=fl31+fjsc(id,iscv(k31))
      pe31=0.5*(wl31*wl31)*a31(i)*fl31/(e31*1.602e-12)
      pe13=(g(3)/g(1))*pe31
      if (pe13.gt.0.) then
         frl=fjsc(id,iscv(k31))/fl31
         frc=1.-frl
         pe13c=pe13*frc
         pe31c=pe31*frc
         pe13l=pe13*frl
         pe31l=pe31*frl
      else
         pe13c=0.d0
         pe31c=0.d0
         pe13l=0.d0
         pe31l=0.d0
      endif
c
      fl41=fjc(j41)/2.41838e14
      fl41=fl41+fjsc(id,iscv(k41))
      pe41=0.5*(wl41*wl41)*a41(i)*fl41/(e41*1.602e-12)
      pe14=(g(4)/g(1))*pe41
      if (pe14.gt.0.) then
         frl=fjsc(id,iscv(k41))/fl41
         frc=1.-frl
         pe14c=pe14*frc
         pe41c=pe41*frc
         pe14l=pe14*frl
         pe41l=pe41*frl
      else
         pe14c=0.d0
         pe41c=0.d0
         pe14l=0.d0
         pe41l=0.d0
      endif
c
      fl51=fjc(j51)/2.41838e14
      fl51=fl51+fjsc(id,iscv(k51))
      pe51=0.5*(wl51*wl51)*a51(i)*fl51/(e51*1.602e-12)
      pe15=(g(5)/g(1))*pe51
      if (pe15.gt.0.) then
         frl=fjsc(id,iscv(k51))/fl51
         frc=1.-frl
         pe15c=pe15*frc
         pe51c=pe51*frc
         pe15l=pe15*frl
         pe51l=pe51*frl
      else
         pe15c=0.d0
         pe51c=0.d0
         pe15l=0.d0
         pe51l=0.d0
      endif
c
      fl32=fjc(j32)/2.41838e14
      fl32=fl32+fjsc(id,iscv(k32))
      pe32=0.5*(wl32*wl32)*a32(i)*fl32/(e32*1.602e-12)
      pe23=(g(3)/g(2))*pe32
      if (pe23.gt.0.) then
         frl=fjsc(id,iscv(k32))/fl32
         frc=1.-frl
         pe23c=pe23*frc
         pe32c=pe32*frc
         pe23l=pe23*frl
         pe32l=pe32*frl
      else
         pe23c=0.d0
         pe32c=0.d0
         pe23l=0.d0
         pe32l=0.d0
      endif
c
      fl42=fjc(j42)/2.41838e14
      fl42=fl42+fjsc(id,iscv(k42))
      pe42=0.5*(wl42*wl42)*a42(i)*fl42/(e42*1.602e-12)
      pe24=(g(4)/g(2))*pe42
      if (pe24.gt.0.) then
         frl=fjsc(id,iscv(k42))/fl42
         frc=1.-frl
         pe24c=pe24*frc
         pe42c=pe42*frc
         pe24l=pe24*frl
         pe42l=pe42*frl
      else
         pe24c=0.d0
         pe42c=0.d0
         pe24l=0.d0
         pe42l=0.d0
      endif
c
      fl52=fjc(j52)/2.41838e14
      fl52=fl52+fjsc(id,iscv(k52))
      pe52=0.5*(wl52*wl52)*a52(i)*fl52/(e52*1.602e-12)
      pe25=(g(5)/g(2))*pe52
      if (pe25.gt.0.) then
         frl=fjsc(id,iscv(k52))/fl52
         frc=1.-frl
         pe25c=pe25*frc
         pe52c=pe52*frc
         pe25l=pe25*frl
         pe52l=pe52*frl
      else
         pe25c=0.d0
         pe52c=0.d0
         pe25l=0.d0
         pe52l=0.d0
      endif
c
      fl43=fjc(j43)/2.41838e14
      fl43=fl43+fjsc(id,iscv(k43))
      pe43=0.5*(wl43*wl43)*a43(i)*fl43/(e43*1.602e-12)
      pe34=(g(4)/g(3))*pe43
      if (pe34.gt.0.) then
         frl=fjsc(id,iscv(k43))/fl43
         frc=1.-frl
         pe34c=pe34*frc
         pe43c=pe43*frc
         pe34l=pe34*frl
         pe43l=pe43*frl
      else
         pe34c=0.d0
         pe43c=0.d0
         pe34l=0.d0
         pe43l=0.d0
      endif
c
      fl54=fjc(j54)/2.41838e14
      fl54=fl54+fjsc(id,iscv(k54))
      pe54=0.5*(wl54*wl54)*a54(i)*fl54/(e54*1.602e-12)
      pe45=(g(5)/g(4))*pe54
      if (pe45.gt.0.) then
         frl=fjsc(id,iscv(k54))/fl54
         frc=1.-frl
         pe45c=pe45*frc
         pe54c=pe54*frc
         pe45l=pe45*frl
         pe54l=pe54*frl
      else
         pe45c=0.d0
         pe54c=0.d0
         pe45l=0.d0
         pe54l=0.d0
      endif
c
c  start-values
      x(1)=1.0
      do j=2,5
	 x(j)=1.d-10
      enddo
c
      do it=1,itmax
c
c calculate the escape probability : p21,p31,p32
c p21
         t0=wl21u3*a21(i)*g(2)*deni*x(1)*(1.-g(1)*x(2)
     &		/(g(2)*x(1)))*time/(8.*pi*g(1))
         if (t0.lt.0.01) then
            p21=1.-0.5*t0+(t0**2)/6.
         elseif(t0.ge.0.01) then
            p21=(1.-fexp(-t0))/t0
         endif
c p31
         t0=wl31u3*a31(i)*g(3)*deni*x(1)*(1.-g(1)*x(3)
     &		/(g(3)*x(1)))*time/(8.*pi*g(1))
         if (t0.lt.0.01) then
            p31=1.-0.5*t0+(t0**2)/6.
         elseif(t0.ge.0.01) then
            p31=(1.-fexp(-t0))/t0
         endif
c p32
         t0=wl32u3*a32(i)*g(3)*deni*x(2)*(1.-g(2)*x(3)
     &		/(g(3)*x(2)))*time/(8.*pi*g(2))
         if (t0.lt.0.01) then
            p32=1.-0.5*t0+(t0**2)/6.
         elseif(t0.ge.0.01) then
            p32=(1.-fexp(-t0))/t0
         endif
c
         if((e43/tev).lt.2.d1) then
c calculate the escape probability : p41,p51,p42,p52,p43,p54
c p41
            t0=wl41u3*a41(i)*g(4)*deni*x(1)*(1.-g(1)*x(4)
     &		/(g(4)*x(1)))*time/(8.*pi*g(1))
            if (t0.lt.0.01) then
               p41=1.-0.5*t0+(t0**2)/6.
            elseif(t0.ge.0.01) then
               p41=(1.-fexp(-t0))/t0
            endif
c p51
            t0=wl51u3*a51(i)*g(5)*deni*x(1)*(1.-g(1)*x(5)
     &		/(g(5)*x(1)))*time/(8.*pi*g(1))
            if (t0.lt.0.01) then
               p51=1.-0.5*t0+(t0**2)/6.
            elseif(t0.ge.0.01) then
               p51=(1.-fexp(-t0))/t0
            endif
c p42
            t0=wl42u3*a42(i)*g(4)*deni*x(2)*(1.-g(2)*x(4)
     &		/(g(4)*x(2)))*time/(8.*pi*g(2))
            if (t0.lt.0.01) then
               p42=1.-0.5*t0+(t0**2)/6.
            elseif(t0.ge.0.01) then
               p42=(1.-fexp(-t0))/t0
            endif
c p52
            t0=wl52u3*a52(i)*g(5)*deni*x(2)*(1.-g(2)*x(5)
     &		/(g(5)*x(2)))*time/(8.*pi*g(2))
            if (t0.lt.0.01) then
               p52=1.-0.5*t0+(t0**2)/6.
            elseif(t0.ge.0.01) then
               p52=(1.-fexp(-t0))/t0
            endif
c p43
            t0=wl43u3*a43(i)*g(4)*deni*x(3)*(1.-g(3)*x(4)
     &		/(g(4)*x(3)))*time/(8.*pi*g(3))
            if (t0.lt.0.01) then
               p43=1.-0.5*t0+(t0**2)/6.
            elseif(t0.ge.0.01) then
               p43=(1.-fexp(-t0))/t0
            endif
c p54
            t0=wl54u3*a54(i)*g(5)*deni*x(4)*(1.-g(4)*x(5)
     &		/(g(5)*x(4)))*time/(8.*pi*g(4))
            if (t0.lt.0.01) then
               p54=1.-0.5*t0+(t0**2)/6.
            elseif(t0.ge.0.01) then
               p54=(1.-fexp(-t0))/t0
            endif
c
            a(1,1)=c12+c13+c14+c15
            a(1,1)=a(1,1)+pe12*p21+pe13*p31+pe14*p41+pe15*p51
            a(1,2)=-(c21+p21*(a21(i)+pe21))
            a(1,3)=-(c31+p31*(a31(i)+pe31))
            a(1,4)=-(c41+p41*(a41(i)+pe41))
            a(1,5)=-(c51+p51*(a51(i)+pe51))
            a(2,1)=-c12-pe12*p21
            a(2,2)=c21+c23+c24+c25+p21*(a21(i)+pe21)
            a(2,2)=a(2,2)+pe23+pe24+pe25
            a(2,3)=-(c32+p32*(a32(i)+pe32))
            a(2,4)=-(c42+p42*(a42(i)+pe42))
            a(2,5)=-(c52+p52*(a52(i)+pe52))
            do j=1,5
               b(j)=0.d0
               a(3,j)=1.d0
            enddo
            b(3)=1.d0
            a(4,1)=-c14-pe14*p41
            a(4,2)=-c24-pe24*p42
            a(4,3)=-c34-pe34*p43
            a(4,4)=c41+c42+c43+c45+p41*(a41(i)+pe41)+
     &           p42*(a42(i)+pe42)+p43*(a43(i)+pe43)+pe45*p54
            a(4,5)=-(c54+p54*(a54(i)+pe54))
            a(5,1)=-c15-pe15*p51
            a(5,2)=-c25-pe25*p52
            a(5,3)=-c35
            a(5,4)=-c45-pe45*p54
            a(5,5)=c51+c52+c53+c54+p51*(a51(i)+pe51)+
     &           p52*(a52(i)+pe52)+p54*(a54(i)+pe54)
c
            call matrixb(5,9)
c
            dxmax=0.
            do j=1,5
               dx=abs((b(j)-x(j))/b(j))
               if (dx.gt.dxmax) dxmax=dx
               x(j)=b(j)
            enddo
c
         else
            a(1,1)=c12+c13+pe12*p21+pe13*p31
            a(1,2)=-(c21+p21*(a21(i)+pe21))
            a(1,3)=-(c31+p31*(a31(i)+pe31))
            a(2,1)=-c12-pe12*p21
            a(2,2)=c21+c23+p21*(a21(i)+pe21)+pe23*p32
            a(2,3)=-(c32+p32*(a32(i)+pe32))
            a(3,1)=1.d0
            a(3,2)=1.d0
            a(3,3)=1.d0
            b(1)=0.0d0
            b(2)=0.0d0
            b(3)=1.d0
c
            call matrixb(3,9)
c
            dxmax=0.
            do j=1,3
               dx=abs((b(j)-x(j))/b(j))
               if (dx.gt.dxmax) dxmax=dx
               x(j)=b(j)
            enddo
c
         endif
c
         if(dxmax.lt.tol) goto 9988
      enddo
      if (it.ge.itmax) write(50,701) 'oforb : no conv!',i,tday,abund,id
9988  continue
 701  format(a,i5,f10.2,1pe12.4,i5)
c
      elab=(1.6022d-12*abund)/dene
      if ((e43/tev).lt.2.d1) then
         co21=elab*(e21*(x(1)*c12-x(2)*c21))
         co32=elab*(e32*(x(2)*c23-x(3)*c32))
         co4t123=elab*(e41*(x(1)*c14-x(4)*c41)+
     &        e42*(x(2)*c24-x(4)*c42)+e43*(x(3)*c34-x(4)*c43))
         co5t12=elab*(e51*(x(1)*c15-x(5)*c51)+
     &        e52*(x(2)*c25-x(5)*c52))
         co54=elab*(e54*(x(4)*c45-x(5)*c54))
         coolx=elab*(e31*(x(1)*c13-x(3)*c31)+e53*(x(3)*c35-x(5)*c53))
c
c         cool=elab*(e21*(x(1)*c12-x(2)*c21)+e31*
c     &	(x(1)*c13-x(3)*c31)+e41*(x(1)*c14-x(4)*c41)+e51*(x(1)*c15-
c     &	x(5)*c51)+e32*(x(2)*c23-x(3)*c32)+
c     &	e42*(x(2)*c24-x(4)*c42)+e52*(x(2)*c25-x(5)*c52)+
c     &	e43*(x(3)*c34-x(4)*c43)+e53*(x(3)*c35-x(5)*c53)+
c     &	e54*(x(4)*c45-x(5)*c54))
c
         f4t123=elab*x(4)*(e41*p41*a41(i)+e42*p42*a42(i)+e43*p43*a43(i))
         fp4t123=elab*(e41*p41*x(4)*pe41+
     &        e42*p42*x(4)*pe42+
     &        e43*p43*x(4)*pe43)
         phextot=phextot+elab*
     &        (e41*p41*(x(1)*pe14-x(4)*pe41)+
     &        e42*p42*(x(2)*pe24-x(4)*pe42)+
     &        e43*p43*(x(3)*pe34-x(4)*pe43))
         phextc=phextc+elab*
     &        (e41*p41*(x(1)*pe14c-x(4)*pe41c)+
     &        e42*p42*(x(2)*pe24c-x(4)*pe42c)+
     &        e43*p43*(x(3)*pe34c-x(4)*pe43c))
c     &        (e41*p41*x(1)*pe14c+
c     &        e42*p42*x(2)*pe24c+
c     &        e43*p43*x(3)*pe34c)
         dphextl=elab*
     &        (e41*p41*(x(1)*pe14l-x(4)*pe41l)+
     &        e42*p42*(x(2)*pe24l-x(4)*pe42l)+
     &        e43*p43*(x(3)*pe34l-x(4)*pe43l))
c     &        (e41*p41*x(1)*pe14l+
c     &        e42*p42*x(2)*pe24l+
c     &        e43*p43*x(3)*pe34l)
         phextl=phextl+dphextl
cqcq run 99 
         phexlm(id,k41)=dphextl
c
c not correct
c         t4t123=0.
cnew9802
         g123=g(1)+g(2)+g(3)
         x123=x(1)+x(2)+x(3)
         a4t123=a41(i)+a42(i)+a43(i)
         t4t123=wl4t123u3*a4t123*g(4)*deni*x123*(1.-g123*x(4)
     &        /(g(4)*x123))*time/(8.*pi*g123)
         if (x(4).gt.1.e-40) then         
            s4t123=(2.*hc/wl4t123u3)/((x123*g(4))/(x(4)*g123)-1)
         else
            s4t123=0.d0
         endif
c
c         fp4t123=elab*(e41*p41*(x(4)*pe41-x(1)*pe14)+
c     &        e42*p42*(x(4)*pe42-x(2)*pe24)+
c     &        e43*p43*(x(4)*pe43-x(3)*pe34))
         f5t12=elab*x(5)*(e51*p51*a51(i)+e52*p52*a52(i))
         fp5t12=elab*(e51*p51*x(5)*pe51+
     &        e52*p52*x(5)*pe52)
         phextot=phextot+elab*
     &        (e51*p51*(x(1)*pe15-x(5)*pe51)+
     &        e52*p52*(x(2)*pe25-x(5)*pe52))
         phextc=phextc+elab*
     &        (e51*p51*(x(1)*pe15c-x(5)*pe51c)+
     &        e52*p52*(x(2)*pe25c-x(5)*pe52c))
c     &        (e51*p51*x(1)*pe15c+
c     &        e52*p52*x(2)*pe25c)
         dphextl=elab*
     &        (e51*p51*(x(1)*pe15l-x(5)*pe51l)+
     &        e52*p52*(x(2)*pe25l-x(5)*pe52l))
c     &        (e51*p51*x(1)*pe15l+
c     &        e52*p52*x(2)*pe25l)
         phextl=phextl+dphextl
cqcq run 99 
         phexlm(id,k51)=dphextl
c
c not correct
c         t5t12=0.
cnew9802
         g12=g(1)+g(2)
         x12=x(1)+x(2)
         a5t12=a51(i)+a52(i)
         t5t12=wl5t12u3*a5t12*g(5)*deni*x12*(1.-g12*x(5)
     &        /(g(5)*x12))*time/(8.*pi*g12)
         if (x(5).gt.1.e-40) then         
            s5t12=(2.*hc/wl5t12u3)/((x12*g(5))/(x(5)*g12)-1)
         else
            s5t12=0.d0
         endif
c
c         fp5t12=elab*(e51*p51*(x(5)*pe51-x(1)*pe15)+
c     &        e52*p52*(x(5)*pe52-x(2)*pe25))
c
         c1=elab*e54*p54
         f54=c1*x(5)*a54(i)
         fp54=c1*x(5)*pe54
         phextot=phextot+c1*(x(4)*pe45-x(5)*pe54)
         phextc=phextc+c1*(x(4)*pe45c-x(5)*pe54c)
         dphextl=c1*(x(4)*pe45l-x(5)*pe54l)
         phextl=phextl+dphextl
cqcq run 99 
         phexlm(id,k54)=dphextl
c
         t54=wl54u3*a54(i)*g(5)*deni*x(4)*(1.-g(4)*x(5)
     &        /(g(5)*x(4)))*time/(8.*pi*g(4))
         if (x(5).gt.1.e-40) then         
            s54=(2.*hc/wl54u3)/((x(4)*g(5))/(x(5)*g(4))-1)
         else
            s54=0.d0
         endif
c
      else
         co21=elab*(e21*(x(1)*c12-x(2)*c21))
         co32=elab*(e32*(x(2)*c23-x(3)*c32))
         coolx=elab*(e31*(x(1)*c13-x(3)*c31))
      endif
c
      cool=co21+co32+co4t123+co5t12+co54+coolx
c
      c1=elab*e21*p21
      f21=c1*x(2)*a21(i)
      fp21=c1*x(2)*pe21
      phextot=phextot+c1*(x(1)*pe12-x(2)*pe21)
      phextc=phextc+c1*(x(1)*pe12c-x(2)*pe21c)
      dphextl=c1*(x(1)*pe12l-x(2)*pe21l)
      phextl=phextl+dphextl
cqcq run 99 
      phexlm(id,k21)=dphextl
c
      t21=wl21u3*a21(i)*g(2)*deni*x(1)*(1.-g(1)*x(2)
     &     /(g(2)*x(1)))*time/(8.*pi*g(1))
      if (x(2).gt.1.e-40) then         
         s21=(2.*hc/wl21u3)/((x(1)*g(2))/(x(2)*g(1))-1)
      else
         s21=0.d0
      endif
c
      c1=elab*e32*p32
      f32=c1*x(3)*a32(i)
      fp32=c1*x(3)*pe32
      phextot=phextot+c1*(x(2)*pe23-x(3)*pe32)
      phextc=phextc+c1*(x(2)*pe23c-x(3)*pe32c)
      dphextl=c1*(x(2)*pe23l-x(3)*pe32l)
      phextl=phextl+dphextl
cqcq run 99 
      phexlm(id,k32)=dphextl
c
      t32=wl32u3*a32(i)*g(3)*deni*x(2)*(1.-g(2)*x(3)
     &     /(g(3)*x(2)))*time/(8.*pi*g(2))
      if (x(3).gt.1.e-40) then         
         s32=(2.*hc/wl32u3)/((x(2)*g(3))/(x(3)*g(2))-1)
      else
         s32=0.d0
      endif
c
      phed(j21)=phed(j21)+elab*p21*e21*(x(1)*pe12-x(2)*pe21)
c      phed(j31)=phed(j31)+elab*p31*e31*x(1)*pe13
      phed(j41)=phed(j41)+elab*p41*e41*(x(1)*pe14-x(4)*pe41)
      phed(j51)=phed(j51)+elab*p51*e51*(x(1)*pe15-x(5)*pe51)
      phed(j32)=phed(j32)+elab*p32*e32*(x(2)*pe23-x(3)*pe32)
      phed(j42)=phed(j42)+elab*p42*e42*(x(2)*pe24-x(4)*pe42)
      phed(j52)=phed(j52)+elab*p52*e52*(x(2)*pe25-x(5)*pe52)
      phed(j43)=phed(j43)+elab*p43*e43*(x(3)*pe34-x(4)*pe43)
      phed(j54)=phed(j54)+elab*p54*e54*(x(4)*pe45-x(5)*pe54)
c
      ENDIF
C
      return
      end
C************************************************************
C************************************************************
      double precision function cheb(tmx,t,a0,a1,a2,a3)
      implicit real*8(a-h,o-z)
C
      y=t
      if(y.lt.5.d3) y=5.d3
      if(y.gt.tmx) y=tmx
      x=0.542519d0*dlog(y)-5.620738d0
      t1=x
      t2=2.d0*x**2-1.d0
      t3=x*(4.d0*x**2-3.d0)
      omlog=0.5d0*a0+a1*t1+a2*t2+a3*t3
      cheb=dexp(omlog)
C
      return
      end
C************************************************************
