      subroutine kurlins(xel,te,kl,klc)
      implicit real*8 (a-h,o-z)
      include 'INCLUDE/DATIE'
      include 'INCLUDE/PARAM.IOR'
      character*20 chkl,kurlab,chc,chh
      common/cemiss/ems(lmax),taus(lmax),wls(lmax),emfrac(lmax),
     &     chkl(lmax),iokl(lmax),iq(lmax),klff,klmax
      common/cabun/amean,ab(mie),xa(mie,mion),xaold(mid,mie,mion),
     &     nion(mie)
      common/cscat/fjsc(mid,0:lmax),kksc(lmax),iscv(0:lmax),
     &           is1(lmax),is0(lmax),is2(lmax),iscm,klsc,iflscat
      common/ctau/tausobi(lmax),tauh1(nm,nm),tauhe1(nl,nl),
     &     tauo1(nl,nl),tauca2(nl,nl),taufe1(nlf1,nlf1),
     &     taufe2(nlf2,nlf2),taufe3(nlf3,nlf3),taufe4(nlf4,nlf4)
      common/csors/sorsi(lmax),sorsh1(nm,nm),sorshe1(nl,nl),
     &     sorso1(nl,nl),sorsca2(nl,nl),sorsfe1(nlf1,nlf1),
     &     sorsfe2(nlf2,nlf2),sorsfe3(nlf3,nlf3),sorsfe4(nlf4,nlf4)
      common/checo/heat,cool,co(mie,mion),emstot,
     &     pheats,pheat(mie,mion),phex,cov(115),hev(35),
     &     comg1(nl,nl),cosi1(nl,nl),chc(115),chh(35),klcm,klhm
      common/depthind/id
      common/cphed/phed(0:ne),phextot,phextc,phextl,phexlm(mid,lmax),
     &     eq1(1200),klq1(1200),kl1m
      common/ckur/wlkur(kurm),akur(kurm),omkur(kurm),
     &     g1kur(kurm),g2kur(kurm),
     &     kurlab(kurm),iekur(kurm),ionkur(kurm),kurlm
c
c assume no excitation by the continuum
      j21=0
c assume no non-thermal excitation (1->2)
      ge2=0.d0
c recombination (to upper level) not included
      alf2=0.d0
c as long as alf2=0 then xa0 and xa1 is not used
      xa0=1.
      xa1=0.
c
c From Regemorter, 1962 (see also Allen)
c xg = sqrt((3*k*T*wl)/(2*h*c)) = constg * sqrt(wl(in A))
c constg = sqrt((3*k*T)/(2*h*c)) = 1.021d-4*sqrt(T) if wl in AA
c
      constg=1.021d-4*dsqrt(te)
c
      do i=1,kurlm
         kl=kl+1
         ie=iekur(i)
         ion=ionkur(i)
         wl=wlkur(i)
         wls(kl)=wl
         z=ab(ie)*xa(ie,ion)
         if (z.gt.0.) then
            fjlsc=fjsc(id,iscv(kl))
c         
c The omega from Regemorter, 1962.
c This value should be multiplied with the
c effective Gaunt factor for neutral atoms and positive
c ions,rgaunt. 
            xg=constg*dsqrt(wl)
            rgaunt=frgaunt(ion,xg)
            om=omkur(i)*rgaunt
c
            g1=g1kur(i)
            g2=g2kur(i)
            a21=akur(i)
c
            call twolat(wl,om,g1,g2,a21,ge2,alf2,xel,
     &           z,xa0,xa1,te,rl,cin,fp21,top,sop,fjlsc,phxl,j21)
c
            phexlm(id,kl)=phxl
            tausobi(kl)=top
            sorsi(kl)=sop
         else
            cin=0.d0
            fp21=0.d0
            tausobi(kl)=0.d0
            sorsi(kl)=0.d0
            rl=0.d0
         endif
         ems(kl)=cin+fp21
         chkl(kl)=kurlab(i)
         coolkur=coolkur+rl
      enddo
      klc=klc+1
      chc(klc)='Kurucz line cool    '
      cov(klc)=coolkur
c
      return
      end


      subroutine readkurl
      implicit real*8 (a-h,o-z)
      include 'INCLUDE/DATIE'
      include 'INCLUDE/PARAM.IOR'
      character*20 kurlab
      character*9 lab_el
      common/ckur/wlkur(kurm),akur(kurm),omkur(kurm),
     &     g1kur(kurm),g2kur(kurm),
     &     kurlab(kurm),iekur(kurm),ionkur(kurm),kurlm
c
      ik=0
c Fe I
      open(55,file='KUR23/fe1.lines',status='old')
      do i=1,10000
         read(55,701,err=99,end=99) lab_el,wl,gl,el,low_lab,
     &gu,eu,up_lab,a,iq
         if (iq.eq.1) then
c include this line
            ik=ik+1
            iekur(ik)=iefe
            ionkur(ik)=1
            kurlab(ik)='Kurucz line'//lab_el
            wlkur(ik)=wl
            akur(ik)=a
c The omega from Regemorter, 1962.
c This value should be multiplied with the
c effective Gaunt factor for neutral atoms and positive
c ions. This is done in subroutine kurlins.
            omkur(ik)=2.388d-18*(wl**3)*gu*a
            g1kur(ik)=gl
            g2kur(ik)=gu
         endif
      enddo
 99   continue
      kurlm=ik
      close(55)
      if (kurlm.gt.kurm) then
         write(50,*)'kurlm>kurm',kurlm,kurm
         stop
      endif
 701  format(a9,f11.4,f6.2,f11.3,a12,1f6.2,f11.3,a12,1pe12.4,i2)
c
      return
      end

      double precision function frgaunt(i,xg)
      implicit real*8 (a-h,o-z)
c These effective gaunt factors for excitation of levels
c are from H. Van Regemorter, ApJ, 136, 906, 1962
      dimension x(10),gn(10),gp(10)
      data x/0.2,0.4,0.6,0.8,1,2,3,4,5,6/
      data gn/0.015,0.034,0.057,0.084,0.124,0.328,
     &0.561,0.775,0.922,1.040/
      data gp/0.2,0.2,0.2,0.2,0.2,0.328,0.561,
     &0.775,0.922,1.040/
c
      g=0.
      if (xg.le.x(1)) then
         if (i.eq.1) then
c neutrals
            g=gn(1)
         elseif (i.ge.2) then
c positive ions
            g=gp(1)
         endif
      elseif (xg.ge.x(10)) then         
         if (i.eq.1) then
c neutrals
            g=gn(10)
         elseif (i.ge.2) then
c positive ions
            g=gp(10)
         endif
      else
         do j=2,10
            if (xg.gt.x(j-1).and.xg.le.x(j)) then
               x1=x(j-1)
               x2=x(j)
               if (i.eq.1) then
c neutrals
                  g1=gn(j-1)
                  g2=gn(j)
               elseif (i.ge.2) then
c positive ions
                  g1=gp(j-1)
                  g2=gp(j)
               endif
               goto 9
            endif
         enddo
 9       continue
         g=g1+(xg-x1)*(g2-g1)/(x2-x1)
      endif
c
      frgaunt=g
c
      return
      end



